/*
*********************************************************************************************************
*
*	ģ : BSPģ(For STM32H7)
*	ļ : bsp.c
*	     : V1.0
*	˵     : Ӳײļÿcļ #include "bsp.h" еģ顣
*			   bsp = Borad surport packet 弶ְ֧
*	޸ļ¼ :
*		汾                  ˵
*		V1.0    2018-07-29  Eric2013   ʽ
*
*	Copyright (C), 2018-2030,  www.armfly.com
*
*********************************************************************************************************
*/
#include "bsp.h"



/*
*********************************************************************************************************
*	                                   
*********************************************************************************************************
*/
static void SystemClock_Config(void);
static void CPU_CACHE_Enable(void);
static void MPU_Config(void);


/*
*********************************************************************************************************
*	  : bsp_Init
*	˵: ʼеӲ豸úCPUĴļĴʼһЩȫֱֻҪһ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_Init(void)
{
    /* MPU */
	MPU_Config();
	
	/* ʹL1 Cache */
	CPU_CACHE_Enable();

	/* 
       STM32H7xx HAL ʼʱϵͳõĻH7Դ64MHzHSIʱ:
	   - úHAL_InitTickʼδʱж1ms
	   - NVIVȼΪ4
	 */
	HAL_Init();

	/* 
       ϵͳʱӵ400MHz
       - лʹHSE
       - ˺ȫֱSystemCoreClockHAL_InitTick
    */
	SystemClock_Config();

	/* 
	   Event Recorder
	   - ڴִʱMDK5.25ϰ汾֧֣IAR֧֡
	   - ĬϲҪʹܴѡؿV7ûֲ8
	*/	
#if Enable_EventRecorder == 1  
	/* ʼEventRecorder */
	EventRecorderInitialize(EventRecordAll, 1U);
	EventRecorderStart();
#endif

	bsp_InitDWT();      /* ʼDWTʱڼ */       
	bsp_InitKey();    	/* ʼҪڵδʱ֮ǰΪťͨδʱɨ */
	bsp_InitTimer();  	/* ʼδʱ */
	bsp_InitUart();		/* ʼ */
	bsp_InitExtIO();	/* ʼFMC74HC574չIO.  bsp_InitLed()ǰִ */	
	bsp_InitLed();    	/* ʼLED */	
    bsp_InitExtSDRAM(); /* ʼSDRAM */
	
	bsp_InitI2C();		/* ʼI2C */
	TOUCH_InitHard();   /* ʼоƬLCDͺŵļҲڴ˺ҪںLCD_InitHardǰ */ 
	LCD_InitHard();     /* ʼLCD */
}

/*
*********************************************************************************************************
*	  : SystemClock_Config
*	˵: ʼϵͳʱ
*            	System Clock source            = PLL (HSE)
*            	SYSCLK(Hz)                     = 400000000 (CPU Clock)
*           	HCLK(Hz)                       = 200000000 (AXI and AHBs Clock)
*            	AHB Prescaler                  = 2
*            	D1 APB3 Prescaler              = 2 (APB3 Clock  100MHz)
*            	D2 APB1 Prescaler              = 2 (APB1 Clock  100MHz)
*            	D2 APB2 Prescaler              = 2 (APB2 Clock  100MHz)
*            	D3 APB4 Prescaler              = 2 (APB4 Clock  100MHz)
*            	HSE Frequency(Hz)              = 25000000
*           	PLL_M                          = 5
*            	PLL_N                          = 160
*            	PLL_P                          = 2
*            	PLL_Q                          = 4
*            	PLL_R                          = 2
*            	VDD(V)                         = 3.3
*            	Flash Latency(WS)              = 4
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void SystemClock_Config(void)
{
	RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
	RCC_OscInitTypeDef RCC_OscInitStruct = {0};
	HAL_StatusTypeDef ret = HAL_OK;

	/* סSCU(Supply configuration update) */
	MODIFY_REG(PWR->CR3, PWR_CR3_SCUEN, 0);

	/* 
      1оƬڲLDOѹĵѹΧѡVOS1VOS2VOS3ͬΧӦͬFlashٶȣ
         鿴οֲTable 12ı
      2ѡʹVOS1ѹΧ1.15V - 1.26V
    */
	__HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

	while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}

	/* ʹHSEѡHSEΪPLLʱԴ */
	RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
	RCC_OscInitStruct.HSEState = RCC_HSE_ON;
	RCC_OscInitStruct.HSIState = RCC_HSI_OFF;
	RCC_OscInitStruct.CSIState = RCC_CSI_OFF;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
	RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
		
	RCC_OscInitStruct.PLL.PLLM = 5;
	RCC_OscInitStruct.PLL.PLLN = 160;
	RCC_OscInitStruct.PLL.PLLP = 2;
	RCC_OscInitStruct.PLL.PLLR = 2;
	RCC_OscInitStruct.PLL.PLLQ = 4;		
		
	RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
	RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_2;	
	ret = HAL_RCC_OscConfig(&RCC_OscInitStruct);
	if(ret != HAL_OK)
	{
        Error_Handler(__FILE__, __LINE__);
	}

	/* 
       ѡPLLΪϵͳʱ
       RCC_CLOCKTYPE_SYSCLKϵͳʱ
       RCC_CLOCKTYPE_HCLK ʱӣӦAHB1AHB2AHB3AHB4
       RCC_CLOCKTYPE_PCLK1ʱӣӦAPB1
       RCC_CLOCKTYPE_PCLK2ʱӣӦAPB2
       RCC_CLOCKTYPE_D1PCLK1ʱӣӦAPB3
       RCC_CLOCKTYPE_D3PCLK1ʱӣӦAPB4     
    */
	RCC_ClkInitStruct.ClockType = (RCC_CLOCKTYPE_SYSCLK | RCC_CLOCKTYPE_HCLK | RCC_CLOCKTYPE_D1PCLK1 | RCC_CLOCKTYPE_PCLK1 | \
								 RCC_CLOCKTYPE_PCLK2  | RCC_CLOCKTYPE_D3PCLK1);

	RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
	RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
	RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV2;
	RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV2;  
	RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2; 
	RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV2; 
	RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV2; 
	
	/* ˺SystemCoreClockHAL_InitTick */
	ret = HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4);
	if(ret != HAL_OK)
	{
        Error_Handler(__FILE__, __LINE__);
	}

    /*
      ʹIOĸģʽҪʹIO 
      1ʹCSI clock
      2ʹSYSCFG clock
      3ʹI/OԪ SYSCFG_CCCSRĴbit0
    */
	__HAL_RCC_CSI_ENABLE() ;

	__HAL_RCC_SYSCFG_CLK_ENABLE() ;

	HAL_EnableCompensationCell();

   /* AXI SRAMʱϵԶʹܵģD2SRAM1SRAM2SRAM3Ҫʹ */	
#if 1
	__HAL_RCC_D2SRAM1_CLK_ENABLE();
	__HAL_RCC_D2SRAM2_CLK_ENABLE();
	__HAL_RCC_D2SRAM3_CLK_ENABLE();
#endif
}

/*
*********************************************************************************************************
*	  : Error_Handler
*	    : file : Դļơؼ __FILE__ ʾԴļ
*			  line кšؼ __LINE__ ʾԴк
*	  ֵ: 
*		Error_Handler(__FILE__, __LINE__);
*********************************************************************************************************
*/
void Error_Handler(char *file, uint32_t line)
{
	/* 
		ûԼĴ뱨Դļʹкţ罫ļкŴӡ
		printf("Wrong parameters value: file %s on line %d\r\n", file, line) 
	*/
	
	/* һѭʧʱڴ˴Աû */
	if (line == 0)
	{
		return;
	}
	
	while(1)
	{
	}
}

/*
*********************************************************************************************************
*	  : MPU_Config
*	˵: MPU
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MPU_Config( void )
{
	MPU_Region_InitTypeDef MPU_InitStruct;

	/* ֹ MPU */
	HAL_MPU_Disable();

#if 1
   	/* AXI SRAMMPUΪWrite back, Read allocateWrite allocate */
	MPU_InitStruct.Enable           = MPU_REGION_ENABLE;
	MPU_InitStruct.BaseAddress      = 0x24000000;
	MPU_InitStruct.Size             = MPU_REGION_SIZE_512KB;
	MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
	MPU_InitStruct.IsBufferable     = MPU_ACCESS_BUFFERABLE;
	MPU_InitStruct.IsCacheable      = MPU_ACCESS_CACHEABLE;
	MPU_InitStruct.IsShareable      = MPU_ACCESS_NOT_SHAREABLE;
	MPU_InitStruct.Number           = MPU_REGION_NUMBER0;
	MPU_InitStruct.TypeExtField     = MPU_TEX_LEVEL1;
	MPU_InitStruct.SubRegionDisable = 0x00;
	MPU_InitStruct.DisableExec      = MPU_INSTRUCTION_ACCESS_ENABLE;

	HAL_MPU_ConfigRegion(&MPU_InitStruct);

 #else
	/* AXI SRAMMPUΪNORMAL, NO Read allocateNO Write allocate */
	MPU_InitStruct.Enable           = MPU_REGION_ENABLE;
	MPU_InitStruct.BaseAddress      = 0x24000000;
	MPU_InitStruct.Size             = MPU_REGION_SIZE_512KB;
	MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
	MPU_InitStruct.IsBufferable     = MPU_ACCESS_NOT_BUFFERABLE;
	MPU_InitStruct.IsCacheable      = MPU_ACCESS_NOT_CACHEABLE;
	MPU_InitStruct.IsShareable      = MPU_ACCESS_NOT_SHAREABLE;
	MPU_InitStruct.Number           = MPU_REGION_NUMBER0;
	MPU_InitStruct.TypeExtField     = MPU_TEX_LEVEL1;
	MPU_InitStruct.SubRegionDisable = 0x00;
	MPU_InitStruct.DisableExec      = MPU_INSTRUCTION_ACCESS_ENABLE;

	HAL_MPU_ConfigRegion(&MPU_InitStruct);
#endif
	
	
	/* FMCչIOMPUΪDeviceStrongly Ordered */
	MPU_InitStruct.Enable           = MPU_REGION_ENABLE;
	MPU_InitStruct.BaseAddress      = 0x60000000;
	MPU_InitStruct.Size             = ARM_MPU_REGION_SIZE_64KB;	
	MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
	MPU_InitStruct.IsBufferable     = MPU_ACCESS_BUFFERABLE;
	MPU_InitStruct.IsCacheable      = MPU_ACCESS_NOT_CACHEABLE;	/* MPU_ACCESS_CACHEABLE;2CSWEź */
	MPU_InitStruct.IsShareable      = MPU_ACCESS_NOT_SHAREABLE;
	MPU_InitStruct.Number           = MPU_REGION_NUMBER1;
	MPU_InitStruct.TypeExtField     = MPU_TEX_LEVEL0;
	MPU_InitStruct.SubRegionDisable = 0x00;
	MPU_InitStruct.DisableExec      = MPU_INSTRUCTION_ACCESS_ENABLE;
	
	HAL_MPU_ConfigRegion(&MPU_InitStruct);
    
    /* SDRAMMPUΪWrite through, read allocateno write allocate */
	MPU_InitStruct.Enable           = MPU_REGION_ENABLE;
	MPU_InitStruct.BaseAddress      = 0xC0000000;
	MPU_InitStruct.Size             = MPU_REGION_SIZE_32MB;
	MPU_InitStruct.AccessPermission = MPU_REGION_FULL_ACCESS;
	MPU_InitStruct.IsBufferable     = MPU_ACCESS_NOT_BUFFERABLE;
	MPU_InitStruct.IsCacheable      = MPU_ACCESS_CACHEABLE;
	MPU_InitStruct.IsShareable      = MPU_ACCESS_NOT_SHAREABLE;
	MPU_InitStruct.Number           = MPU_REGION_NUMBER2;
	MPU_InitStruct.TypeExtField     = MPU_TEX_LEVEL0;
	MPU_InitStruct.SubRegionDisable = 0x00;
	MPU_InitStruct.DisableExec      = MPU_INSTRUCTION_ACCESS_ENABLE;

	HAL_MPU_ConfigRegion(&MPU_InitStruct);

	/*ʹ MPU */
	HAL_MPU_Enable(MPU_PRIVILEGED_DEFAULT);
}

/*
*********************************************************************************************************
*	  : CPU_CACHE_Enable
*	˵: ʹL1 Cache
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void CPU_CACHE_Enable(void)
{
	/* ʹ I-Cache */
	SCB_EnableICache();

	/* ʹ D-Cache */
	SCB_EnableDCache();
}

/*
*********************************************************************************************************
*	  : bsp_RunPer10ms
*	˵: úÿ10msSystickжϵ1Ρ bsp_timer.cĶʱжϷһЩʱҪϸ
*			Էڴ˺磺ɨ衢пƵȡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_RunPer10ms(void)
{
	bsp_KeyScan10ms();
}

/*
*********************************************************************************************************
*	  : bsp_RunPer1ms
*	˵: úÿ1msSystickжϵ1Ρ bsp_timer.cĶʱжϷһЩҪԴ
*			 Էڴ˺磺ɨ衣
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_RunPer1ms(void)
{
	TOUCH_Scan();	/*  */
}

/*
*********************************************************************************************************
*	  : bsp_Idle
*	˵: ʱִеĺһforwhileѭҪ CPU_IDLE() ñ
*			 ȱʡΪղûιCPUģʽĹܡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_Idle(void)
{
	/* --- ι */

	/* --- CPUߣSystickʱжϻѻжϻ */

	/*  emWin ͼο⣬ԲͼοҪѯ */
	//GUI_Exec();

	/*  uIP Э飬Բuipѯ */
	TOUCH_CapScan();
}

/*
*********************************************************************************************************
*	  : HAL_Delay
*	˵: ضӳٺ滻HALеĺΪHALеȱʡSystickжϣUSBSD
*             жӳٺҲͨHAL_NVIC_SetPrioritySystickж
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
/* ǰʹstm32h7xx_hal.cĬϷʽʵ֣δʹضĺ */
#if 0
void HAL_Delay(uint32_t Delay)
{
	bsp_DelayUS(Delay * 1000);
}
#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
