/*
*********************************************************************************************************
*
*	ģ : ж+FIFOģ
*	ļ : bsp_uart_fifo.h
*	˵     : ͷļ
*
*	Copyright (C), 2015-2020,  www.armfly.com
*
*********************************************************************************************************
*/

#ifndef _BSP_USART_FIFO_H_
#define _BSP_USART_FIFO_H_

/*
	STM32-V7 ڷ䣺
	1 RS232 оƬ1·
		PA9/USART1_TX	  --- ӡԿ
		P10/USART1_RX

	2 PA2 ̫ܽ RXܽڽGPSź
		PA2/USART2_TX/ETH_MDIO (̫ڷ)
		PA3/USART2_RX	;GPSģ

	3 RS485 ͨ - TTL   
		PB10/USART3_TX
		PB11/USART3_RX

	4 --- á SDռ 
	5 --- á SDռ

	6--- GPRSģ WIFIģ(ESP8266) 
		PC6/USART6_TX
		PC7/USART6_RX
		
	7 --- á SPI3ռ
	
	8 --- á LTDCʾӿ
*/


#define	UART1_FIFO_EN	1
#define	UART2_FIFO_EN	0
#define	UART3_FIFO_EN	1
#define	UART4_FIFO_EN	0
#define	UART5_FIFO_EN	0
#define	UART6_FIFO_EN	0
#define	UART7_FIFO_EN	0
#define	UART8_FIFO_EN	0

/* PB2 RS485оƬķʹ */
#define RS485_TXEN_GPIO_CLK_ENABLE()      __HAL_RCC_GPIOB_CLK_ENABLE()
#define RS485_TXEN_GPIO_PORT              GPIOB
#define RS485_TXEN_PIN                    GPIO_PIN_2

//#define RS485_RX_EN()	RS485_TXEN_GPIO_PORT->BSRRH = RS485_TXEN_PIN
//#define RS485_TX_EN()	RS485_TXEN_GPIO_PORT->BSRRL = RS485_TXEN_PIN

#define RS485_RX_EN()	RS485_TXEN_GPIO_PORT->BSRR = ((uint32_t)RS485_TXEN_PIN << 16U)
#define RS485_TX_EN()	RS485_TXEN_GPIO_PORT->BSRR = RS485_TXEN_PIN

/* ˿ں */
typedef enum
{
	COM1 = 0,	/* USART1 */
	COM2 = 1,	/* USART2 */
	COM3 = 2,	/* USART3 */
	COM4 = 3,	/* UART4 */
	COM5 = 4,	/* UART5 */
	COM6 = 5,	/* USART6 */
	COM7 = 6,	/* UART7 */	
	COM8 = 7	/* UART8 */	
}COM_PORT_E;

/* 崮ڲʺFIFOСΪͻͽջ, ֧ȫ˫ */
#if UART1_FIFO_EN == 1
	#define UART1_BAUD			115200
	#define UART1_TX_BUF_SIZE	1*1024
	#define UART1_RX_BUF_SIZE	1*1024
#endif

#if UART2_FIFO_EN == 1
	#define UART2_BAUD			9600
	#define UART2_TX_BUF_SIZE	10
	#define UART2_RX_BUF_SIZE	2*1024
#endif

#if UART3_FIFO_EN == 1
	#define UART3_BAUD			9600
	#define UART3_TX_BUF_SIZE	1*1024
	#define UART3_RX_BUF_SIZE	1*1024
#endif

#if UART4_FIFO_EN == 1
	#define UART4_BAUD			115200
	#define UART4_TX_BUF_SIZE	1*1024
	#define UART4_RX_BUF_SIZE	1*1024
#endif

#if UART5_FIFO_EN == 1
	#define UART5_BAUD			115200
	#define UART5_TX_BUF_SIZE	1*1024
	#define UART5_RX_BUF_SIZE	1*1024
#endif

#if UART6_FIFO_EN == 1
	#define UART6_BAUD			115200
	#define UART6_TX_BUF_SIZE	1*1024
	#define UART6_RX_BUF_SIZE	1*1024
#endif

#if UART7_FIFO_EN == 1
	#define UART7_BAUD			115200
	#define UART7_TX_BUF_SIZE	1*1024
	#define UART7_RX_BUF_SIZE	1*1024
#endif

#if UART8_FIFO_EN == 1
	#define UART8_BAUD			115200
	#define UART8_TX_BUF_SIZE	1*1024
	#define UART8_RX_BUF_SIZE	1*1024
#endif

/* 豸ṹ */
typedef struct
{
	USART_TypeDef *uart;		/* STM32ڲ豸ָ */
	uint8_t *pTxBuf;			/* ͻ */
	uint8_t *pRxBuf;			/* ջ */
	uint16_t usTxBufSize;		/* ͻС */
	uint16_t usRxBufSize;		/* ջС */
	__IO uint16_t usTxWrite;	/* ͻдָ */
	__IO uint16_t usTxRead;		/* ͻָ */
	__IO uint16_t usTxCount;	/* ȴ͵ݸ */

	__IO uint16_t usRxWrite;	/* ջдָ */
	__IO uint16_t usRxRead;		/* ջָ */
	__IO uint16_t usRxCount;	/* δȡݸ */

	void (*SendBefor)(void); 	/* ʼ֮ǰĻصָ루ҪRS485лģʽ */
	void (*SendOver)(void); 	/* ϵĻصָ루ҪRS485ģʽлΪģʽ */
	void (*ReciveNew)(uint8_t _byte);	/* յݵĻصָ */
	uint8_t Sending;			/* ڷ */
}UART_T;

void bsp_InitUart(void);
void comSendBuf(COM_PORT_E _ucPort, uint8_t *_ucaBuf, uint16_t _usLen);
void comSendChar(COM_PORT_E _ucPort, uint8_t _ucByte);
uint8_t comGetChar(COM_PORT_E _ucPort, uint8_t *_pByte);
void comSendBuf(COM_PORT_E _ucPort, uint8_t *_ucaBuf, uint16_t _usLen);
void comClearTxFifo(COM_PORT_E _ucPort);
void comClearRxFifo(COM_PORT_E _ucPort);
void comSetBaud(COM_PORT_E _ucPort, uint32_t _BaudRate);

void USART_SetBaudRate(USART_TypeDef* USARTx, uint32_t BaudRate);
void bsp_SetUartParam(USART_TypeDef *Instance,  uint32_t BaudRate, uint32_t Parity, uint32_t Mode);

void RS485_SendBuf(uint8_t *_ucaBuf, uint16_t _usLen);
void RS485_SendStr(char *_pBuf);
void RS485_SetBaud(uint32_t _baud);
uint8_t UartTxEmpty(COM_PORT_E _ucPort);

#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
