/*
*********************************************************************************************************
*
*	ģ : STM32ڲRTCģ
*	ļ : bsp_cpu_rtc.h
*	     : V1.0
*	˵     : ͷļ
*
*	޸ļ¼ :
*		汾             ˵
*		v1.0    2015-08-08 armfly  װ.ԭ
*
*	Copyright (C), 2015-2016,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

#define RTC_INIT_FLAG	0xA5A8

#define RTC_ASYNCH_PREDIV  0x7F
#define RTC_SYNCH_PREDIV   0x00FF

RTC_T g_tRTC;

/* ƽÿ */
const uint8_t mon_table[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

static void RTC_Config(void);

RTC_HandleTypeDef RtcHandle;	/* ȫֱ */

/*
*********************************************************************************************************
*	  : bsp_InitRTC
*	˵: ʼCPUڲRTC
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitRTC(void)
{	
	uint32_t back_reg;

	RtcHandle.Instance = RTC;	
	
	/* ڼǷѾùRTCùĻýʱ 
	RTCݼĴΪ0xA5A5 RTCݼĴ0xA5A5   ôʾûùҪRTC.   */
	back_reg = HAL_RTCEx_BKUPRead(&RtcHandle, RTC_BKP_DR0); 
	if (back_reg != RTC_INIT_FLAG) 
	{ 		
		RTC_Config(); 	/* RTC  */ 
		
		RTC_WriteClock(2018, 9, 1, 0, 0, 0);	/* óʼʱ */
		
		/* ñݼĴʾѾùRTC */
		HAL_RTCEx_BKUPWrite(&RtcHandle, RTC_BKP_DR0, RTC_INIT_FLAG);		
	} 
	else 
	{ 
		/* ϵ縴λ־Ƿ */ 
		if (__HAL_RCC_GET_FLAG(RCC_FLAG_PORRST) != 0)
		{ 
			/* ϵ縴λ */ 
		} 
		/* Ÿλ־Ƿ */ 
		else if (__HAL_RCC_GET_FLAG(RCC_FLAG_PINRST) != 0) 
		{ 
			/* Ÿλ */  
		} 
		
		RTC_Config(); 	/* RTC  */ 
	}
}

/*
*********************************************************************************************************
*	  : RTC_Config
*	˵: 1. ѡͬRTCʱԴLSILSE
*             2. RTCʱӡ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void RTC_Config(void)
{
	RCC_OscInitTypeDef        RCC_OscInitStruct;
	RCC_PeriphCLKInitTypeDef  PeriphClkInitStruct;

	/* To enable access on RTC registers */
	HAL_PWR_EnableBkUpAccess();
	
	/* Configure LSE/LSI as RTC clock source ###############################*/
	RCC_OscInitStruct.OscillatorType =  RCC_OSCILLATORTYPE_LSI | RCC_OSCILLATORTYPE_LSE;
	RCC_OscInitStruct.PLL.PLLState = RCC_PLL_NONE;
	RCC_OscInitStruct.LSEState = RCC_LSE_ON;
	RCC_OscInitStruct.LSIState = RCC_LSI_OFF;
	if(HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
	{ 
		Error_Handler(__FILE__, __LINE__);
	}

	PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_RTC;
	PeriphClkInitStruct.RTCClockSelection = RCC_RTCCLKSOURCE_LSE;
	if(HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct) != HAL_OK)
	{ 
		Error_Handler(__FILE__, __LINE__);
	}
	
	/* Configures the External Low Speed oscillator (LSE) drive capability */
	__HAL_RCC_LSEDRIVE_CONFIG(RCC_LSEDRIVE_HIGH);	
	
	/* Enable RTC Clock */ 
	__HAL_RCC_RTC_ENABLE(); 
  
	/* Configure RTC prescaler and RTC data registers */	
	{
	 
		RtcHandle.Instance = RTC;

		/* RTC configured as follows:
		  - Hour Format    = Format 24
		  - Asynch Prediv  = Value according to source clock
		  - Synch Prediv   = Value according to source clock
		  - OutPut         = Output Disable
		  - OutPutPolarity = High Polarity
		  - OutPutType     = Open Drain */
		RtcHandle.Init.HourFormat     = RTC_HOURFORMAT_24;
		RtcHandle.Init.AsynchPrediv   = RTC_ASYNCH_PREDIV;
		RtcHandle.Init.SynchPrediv    = RTC_SYNCH_PREDIV;
		RtcHandle.Init.OutPut         = RTC_OUTPUT_DISABLE;
		RtcHandle.Init.OutPutPolarity = RTC_OUTPUT_POLARITY_HIGH;
		RtcHandle.Init.OutPutType     = RTC_OUTPUT_TYPE_OPENDRAIN;
		if (HAL_RTC_Init(&RtcHandle) != HAL_OK)
		{
			/* Initialization Error */
			Error_Handler(__FILE__, __LINE__);
		}	
	}
}

/*
*********************************************************************************************************
*	  : RTC_WriteClock
*	˵: RTCʱ
*	    Σ
*	  ֵ: 1ʾɹ 0ʾ
*********************************************************************************************************
*/
uint8_t RTC_WriteClock(uint16_t _year, uint8_t _mon, uint8_t _day, uint8_t _hour, uint8_t _min, uint8_t _sec)
{
	RTC_DateTypeDef  date;
	RTC_TimeTypeDef  time;

	RtcHandle.Instance = RTC;
	
	/* պ */
	date.Year = _year - 2000;
	date.Month = _mon;
	date.Date = _day;
	date.WeekDay = RTC_CalcWeek(_year, _mon, _day);	/* 5=5 =7 */
	if (HAL_RTC_SetDate(&RtcHandle, &date, FORMAT_BIN) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	} 

	/* ʱ룬Լʾʽ */
	time.Hours   = _hour;
	time.Minutes = _min;
	time.Seconds = _sec; 
	time.TimeFormat = RTC_HOURFORMAT12_AM;
	time.DayLightSaving = RTC_DAYLIGHTSAVING_NONE ;
	time.StoreOperation = RTC_STOREOPERATION_RESET;	
	if(HAL_RTC_SetTime(&RtcHandle, &time, FORMAT_BIN) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}  

	return 1;      
}

/*
*********************************************************************************************************
*	  : RTC_ReadClock
*	˵: õǰʱӡ g_tRTC
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void RTC_ReadClock(void)
{
	RTC_DateTypeDef  date;
	RTC_TimeTypeDef  time;

	RtcHandle.Instance = RTC;
	
	/* CPU BUG: ȶȡʱ䣬ٶȡ */
	if (HAL_RTC_GetTime(&RtcHandle, &time, FORMAT_BIN) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	} 	
	
	if (HAL_RTC_GetDate(&RtcHandle, &date, FORMAT_BIN) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	} 
	
	g_tRTC.Year = date.Year + 2000;
	g_tRTC.Mon = date.Month;
	g_tRTC.Day = date.Date;
	
	g_tRTC.Hour = time.Hours;	/* Сʱ */
	g_tRTC.Min = time.Minutes; 	/*  */
	g_tRTC.Sec = time.Seconds;	/*  */

	g_tRTC.Week = RTC_CalcWeek(g_tRTC.Year, g_tRTC.Mon, g_tRTC.Day);	/*  */
}   


/*
*********************************************************************************************************
*	  : bsp_CalcWeek
*	˵: ڼڼ
*	    : _year _mon _day    (2ֽºֽ
*	  ֵ: ܼ 1-7 7ʾ
*********************************************************************************************************
*/
uint8_t RTC_CalcWeek(uint16_t _year, uint8_t _mon, uint8_t _day)
{
	/*
	գZellerʽ
		ʷϵĳһڼδĳһڼ⣬кܶ㹫ʽͨü㹫ʽ
	һЩֶμ㹫ʽǲգZellerʽ
	    w=y+[y/4]+[c/4]-2c+[26(m+1)/10]+d-1

		ʽеķź£
	     wڣ
	     cĸ2λ-1
	     y꣨λ
	     m£mڵ3Сڵ14ڲչʽУĳ12Ҫһ1314㣬
	  	    200311Ҫ2002131㣩
	     dգ
	     [ ]ȡֻҪ֡

	    W7Ǽڼ0Ϊա
        ǸҪ⴦
            ܰϰߵĸֻܰеĶࡣΪ˷
        㣬ǿԸһ7ʹΪһȻ

		2049101գ100죩ΪòգZellerʽм㣬£
		գZellerʽw=y+[y/4]+[c/4]-2c+[26(m+1)/10]+d-1
		=49+[49/4]+[20/4]-220+[26 (10+1)/10]+1-1
		=49+[12.25]+5-40+[28.6]
		=49+12+5-40+28
		=54 (75)
		2049101գ100죩5
	*/
	uint8_t y, c, m, d;
	int16_t w;

	if (_mon >= 3)
	{
		m = _mon;
		y = _year % 100;
		c = _year / 100;
		d = _day;
	}
	else	/* ĳ12Ҫһ1314 */
	{
		m = _mon + 12;
		y = (_year - 1) % 100;
		c = (_year - 1) / 100;
		d = _day;
	}

	w = y + y / 4 +  c / 4 - 2 * c + ((uint16_t)26*(m+1))/10 + d - 1;
	if (w == 0)
	{
		w = 7;	/* ʾ */
	}
	else if (w < 0)	/* wǸʽͬ */
	{
		w = 7 - (-w) % 7;
	}
	else
	{
		w = w % 7;
	}
	
	/* 2018-10-20 else棬w0 */
	if (w == 0)
	{
		w = 7;	/* ʾ */
	}
	
	return w;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
