/*
*********************************************************************************************************
*
*	ģ : AD7606ݲɼģ
*	ļ : bsp_ad7606.c
*	     : V1.0
*	˵     : AD7606STM32FMCϡ
*
*			ʹ TIM3 ΪӲʱʱADCת
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2015-10-11 armfly  ʽ
*
*	Copyright (C), 2015-2020,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	STM32-V7 + AD7606ģ飬 ƲɼIO:
	
	PC6/TIM3_CH1/TIM8_CH1     ----> AD7606_CONVST  (ͷ),  PWMΪADCź
	PE5/DCMI_D6/AD7606_BUSY   <---- AD7606_BUSY    , CPUBUSYжϷжȡɼ
*/

#include "bsp.h"

/* CONVST ADCתGPIO = PC6 */
#define CONVST_RCC_GPIO_CLK_ENABLE	__HAL_RCC_GPIOC_CLK_ENABLE
#define CONVST_GPIO		GPIOC
#define CONVST_PIN		GPIO_PIN_6
#define CONVST_TIMX		TIM8
#define CONVST_TIMCH	1

/* BUSY תź = PE5 */
#define BUSY_RCC_GPIO_CLK_ENABLE	__HAL_RCC_GPIOE_CLK_ENABLE
#define BUSY_GPIO		GPIOE
#define BUSY_PIN		GPIO_PIN_5
#define BUSY_IRQn		EXTI9_5_IRQn
#define BUSY_IRQHandler	EXTI9_5_IRQHandler

/* ùIO, չ74HC574 */
#define OS0_1()		HC574_SetPin(AD7606_OS0, 1)
#define OS0_0()		HC574_SetPin(AD7606_OS0, 0)
#define OS1_1()		HC574_SetPin(AD7606_OS1, 1)
#define OS1_0()		HC574_SetPin(AD7606_OS1, 0)
#define OS2_1()		HC574_SetPin(AD7606_OS2, 1)
#define OS2_0()		HC574_SetPin(AD7606_OS2, 0)

/* ADתGPIO : PC6 */
#define CONVST_1()	CONVST_GPIO->BSRRL = CONVST_PIN
#define CONVST_0()	CONVST_GPIO->BSRRH = CONVST_PIN

/* ̵GPIO, չ74HC574 */
#define RANGE_1()	HC574_SetPin(AD7606_RANGE, 1)
#define RANGE_0()	HC574_SetPin(AD7606_RANGE, 0)

/* AD7606λ, չ74HC574 */
#define RESET_1()	HC574_SetPin(AD7606_RESET, 1)
#define RESET_0()	HC574_SetPin(AD7606_RESET, 0)

/* AD7606 FSMCߵַֻܶд */
#define AD7606_RESULT()	*(__IO uint16_t *)0x60003000

AD7606_VAR_T g_tAD7606;		/* 1ȫֱһЩ */
AD7606_FIFO_T g_tAdcFifo;	/* FIFOṹ */

static void AD7606_CtrlLinesConfig(void);
static void AD7606_FSMCConfig(void);

/*
*********************************************************************************************************
*	  : bsp_InitAD7606
*	˵: ⲿSRAMGPIOFSMC
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitAD7606(void)
{
	AD7606_CtrlLinesConfig();
	AD7606_FSMCConfig();

	AD7606_SetOS(AD_OS_NO);		/* ޹ */
	AD7606_SetInputRange(0);	/* 0ʾΪ5V, 1ʾ10V */

	AD7606_Reset();

	CONVST_1();					/* תGPIOƽʱΪ */
}

/*
*********************************************************************************************************
*	  : AD7606_CtrlLinesConfig
*	˵: GPIOߣFMCܽΪù
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
/*
	STM32-V7߷
	PD0/FMC_D2
	PD1/FMC_D3
	PD4/FMC_NOE		---- źţOE = Output Enable  N ʾЧ
	PD5/FMC_NWE		-XX- дźţAD7606 ֻждź
	PD8/FMC_D13
	PD9/FMC_D14
	PD10/FMC_D15
	PD14/FMC_D0
	PD15/FMC_D1

	PE7/FMC_D4
	PE8/FMC_D5
	PE9/FMC_D6
	PE10/FMC_D7
	PE11/FMC_D8
	PE12/FMC_D9
	PE13/FMC_D10
	PE14/FMC_D11
	PE15/FMC_D12
	
	PG0/FMC_A10		--- ƬѡFMC_NE2һ
	PG1/FMC_A11		--- ƬѡFMC_NE2һ
	PG9/FMC_NE2		--- ƬѡTFT, OLED  AD7606	
*/

/* 
	AD7606IOչ74HC574
	X13 - AD7606_OS0
	X14 - AD7606_OS1
	X15 - AD7606_OS2
	X24 - AD7606_RESET
	X25 - AD7606_RAGE	
	
	PE5 - AD7606_BUSY
*/
static void AD7606_CtrlLinesConfig(void)
{
	/* bsp_fm_io fmc ˴ظ 
		bsp_InitExtIO();
	*/
	
	/*

	PD0/FMC_D2
	PD1/FMC_D3
	PD4/FMC_NOE		---- źţOE = Output Enable  N ʾЧ
	PD5/FMC_NWE		-XX- дźţAD7606 ֻждź
	PD8/FMC_D13
	PD9/FMC_D14
	PD10/FMC_D15
	PD14/FMC_D0
	PD15/FMC_D1

	PE7/FMC_D4
	PE8/FMC_D5
	PE9/FMC_D6
	PE10/FMC_D7
	PE11/FMC_D8
	PE12/FMC_D9
	PE13/FMC_D10
	PE14/FMC_D11
	PE15/FMC_D12
	
	PG0/FMC_A10		--- ƬѡFMC_NE2һ
	PG1/FMC_A11		--- ƬѡFMC_NE2һ
	PG9/FMC_NE2		--- ƬѡOLED, 74HC574, DM9000, AD7606	
	
//	PF0/FMC_A0      ---- RS
	*/	

	GPIO_InitTypeDef gpio_init_structure;

	/* ʹ GPIOʱ */
	__HAL_RCC_GPIOD_CLK_ENABLE();
	__HAL_RCC_GPIOE_CLK_ENABLE();
	__HAL_RCC_GPIOF_CLK_ENABLE();
	__HAL_RCC_GPIOG_CLK_ENABLE();
	__HAL_RCC_GPIOH_CLK_ENABLE();
	__HAL_RCC_GPIOI_CLK_ENABLE();

	/* ʹFMCʱ */
	__HAL_RCC_FMC_CLK_ENABLE();

	/*  GPIOD صIOΪ */
	gpio_init_structure.Mode = GPIO_MODE_AF_PP;
	gpio_init_structure.Pull = GPIO_PULLUP;
	gpio_init_structure.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
	gpio_init_structure.Alternate = GPIO_AF12_FMC;
	
	/* GPIOD */
	gpio_init_structure.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_4 | GPIO_PIN_5 |
	                            GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_14 |
	                            GPIO_PIN_15;
	HAL_GPIO_Init(GPIOD, &gpio_init_structure);

	/* GPIOE */
	gpio_init_structure.Pin = GPIO_PIN_7 | GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 |
	                            GPIO_PIN_11 | GPIO_PIN_12 | GPIO_PIN_13 | GPIO_PIN_14 |
	                            GPIO_PIN_15;
	HAL_GPIO_Init(GPIOE, &gpio_init_structure);

	/* GPIOG */
	gpio_init_structure.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_9;
	HAL_GPIO_Init(GPIOG, &gpio_init_structure);
	
	/* GPIOH */
	gpio_init_structure.Pin = GPIO_PIN_8 | GPIO_PIN_9 | GPIO_PIN_10 | GPIO_PIN_11 | GPIO_PIN_12
						| GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15;
	HAL_GPIO_Init(GPIOH, &gpio_init_structure);

	/* GPIOI */
	gpio_init_structure.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_6
						| GPIO_PIN_7 | GPIO_PIN_9 | GPIO_PIN_10;
	HAL_GPIO_Init(GPIOI, &gpio_init_structure);
}

/*
*********************************************************************************************************
*	  : AD7606_FSMCConfig
*	˵: FSMCڷʱ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void AD7606_FSMCConfig(void)
{
	/* bsp_fm_io fmc ˴ظ 
		bsp_InitExtIO();
	*/
	/*
		AD7606Ҫ(3.3Vʱ)RDźŵ͵ƽ21nsߵƽ̿15ns

		 Ϊ˺ͬBANKLCDͬѡ3-0-6-1-0-0
		3-0-5-1-0-0  : RD߳75ns ͵ƽ50ns.  1usڿɶȡ8·ݵڴ档
		1-0-1-1-0-0  : RD75ns͵ƽִ12nsң½زҲ12ns.  ݶȡȷ
	*/
	SRAM_HandleTypeDef hsram = {0};
	FMC_NORSRAM_TimingTypeDef SRAM_Timing = {0};
		
	/*
		AD7606Ҫ(3.3Vʱ)RDźŵ͵ƽ21nsߵƽ̿15ns

		 Ϊ˺ͬBANKLCDͬѡ3-0-6-1-0-0
		3-0-5-1-0-0  : RD߳75ns ͵ƽ50ns.  1usڿɶȡ8·ݵڴ档
		1-0-1-1-0-0  : RD75ns͵ƽִ12nsң½زҲ12ns.  ݶȡȷ
	*/
	hsram.Instance  = FMC_NORSRAM_DEVICE;
	hsram.Extended  = FMC_NORSRAM_EXTENDED_DEVICE;

	/* SRAM ʱ */  
	SRAM_Timing.AddressSetupTime       = 4;
	SRAM_Timing.AddressHoldTime        = 1;
	SRAM_Timing.DataSetupTime          = 5;
	SRAM_Timing.BusTurnAroundDuration  = 3;
	SRAM_Timing.CLKDivision            = 2;
	SRAM_Timing.DataLatency            = 2;
	SRAM_Timing.AccessMode             = FMC_ACCESS_MODE_A;

	hsram.Init.NSBank             = FMC_NORSRAM_BANK1;
	hsram.Init.DataAddressMux     = FMC_DATA_ADDRESS_MUX_DISABLE;
	hsram.Init.MemoryType         = FMC_MEMORY_TYPE_SRAM;
	hsram.Init.MemoryDataWidth    = FMC_NORSRAM_MEM_BUS_WIDTH_32;	/* 32λ߿ */
	hsram.Init.BurstAccessMode    = FMC_BURST_ACCESS_MODE_DISABLE;
	hsram.Init.WaitSignalPolarity = FMC_WAIT_SIGNAL_POLARITY_LOW;
	hsram.Init.WaitSignalActive   = FMC_WAIT_TIMING_BEFORE_WS;
	hsram.Init.WriteOperation     = FMC_WRITE_OPERATION_ENABLE;
	hsram.Init.WaitSignal         = FMC_WAIT_SIGNAL_DISABLE;
	hsram.Init.ExtendedMode       = FMC_EXTENDED_MODE_DISABLE;
	hsram.Init.AsynchronousWait   = FMC_ASYNCHRONOUS_WAIT_DISABLE;
	hsram.Init.WriteBurst         = FMC_WRITE_BURST_DISABLE;
	hsram.Init.ContinuousClock    = FMC_CONTINUOUS_CLOCK_SYNC_ONLY;

	/* ʼSRAM */
	if (HAL_SRAM_Init(&hsram, &SRAM_Timing, &SRAM_Timing) != HAL_OK)
	{
		/* ʼ */
		Error_Handler(__FILE__, __LINE__);
	}	
}

/*
*********************************************************************************************************
*	  : AD7606_SetOS
*	˵: AD7606˲Ҳùʡ
*			 ͨ AD7606_OS0OS1OS2ߵĵƽ״̬ʡ
*			 ADת֮AD7606ڲԶʵʣĲɼȻƽֵ
*
*			 ԽߣתʱԽ
*			 ޹ʱADתʱ 4us;
*				2ʱ = 8.7us;
*				4ʱ = 16us
*			 	64ʱ = 286us
*
*	    : _ucOS : , 0 - 6
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_SetOS(uint8_t _ucOS)
{
	g_tAD7606.ucOS = _ucOS;
	switch (_ucOS)
	{
		case AD_OS_X2:
			OS2_0();
			OS1_0();
			OS0_1();
			break;

		case AD_OS_X4:
			OS2_0();
			OS1_1();
			OS0_0();
			break;

		case AD_OS_X8:
			OS2_0();
			OS1_1();
			OS0_1();
			break;

		case AD_OS_X16:
			OS2_1();
			OS1_0();
			OS0_0();
			break;

		case AD_OS_X32:
			OS2_1();
			OS1_0();
			OS0_1();
			break;

		case AD_OS_X64:
			OS2_1();
			OS1_1();
			OS0_0();
			break;

		case AD_OS_NO:
		default:
			g_tAD7606.ucOS = AD_OS_NO;
			OS2_0();
			OS1_0();
			OS0_0();
			break;
	}
}

/*
*********************************************************************************************************
*	  : AD7606_SetInputRange
*	˵: AD7606ģź̡
*	    : _ucRange : 0 ʾ5V   1ʾ10V
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_SetInputRange(uint8_t _ucRange)
{
	if (_ucRange == 0)
	{
		g_tAD7606.ucRange = 0;
		RANGE_0();	/* Ϊ5V */
	}
	else
	{
		g_tAD7606.ucRange = 1;
		RANGE_1();	/* Ϊ10V */
	}
}

/*
*********************************************************************************************************
*	  : AD7606_Reset
*	˵: ӲλAD7606λָ֮״̬
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_Reset(void)
{
	RESET_0();	/* ˳λ״̬ */

	RESET_1();	/* 븴λ״̬ */
	RESET_1();	/* ӳ١ RESETλߵƽС50ns */
	RESET_1();
	RESET_1();

	RESET_0();	/* ˳λ״̬ */
}

/*
*********************************************************************************************************
*	  : AD7606_StartConvst
*	˵: 1ADCת
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StartConvst(void)
{
	/* page 7  CONVST ߵƽȺ͵͵ƽ 25ns */
	/* CONVSTƽʱΪ */
	CONVST_0();
	CONVST_0();
	CONVST_0();

	CONVST_1();
}

/*
*********************************************************************************************************
*	  : AD7606_ReadNowAdc
*	˵: ȡ8·洢ȫֱ g_tAD7606
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_ReadNowAdc(void)
{
	g_tAD7606.sNowAdc[0] = AD7606_RESULT();	/* 1· */
	g_tAD7606.sNowAdc[1] = AD7606_RESULT();	/* 2· */
	g_tAD7606.sNowAdc[2] = AD7606_RESULT();	/* 3· */
	g_tAD7606.sNowAdc[3] = AD7606_RESULT();	/* 4· */
	g_tAD7606.sNowAdc[4] = AD7606_RESULT();	/* 5· */
	g_tAD7606.sNowAdc[5] = AD7606_RESULT();	/* 6· */
	g_tAD7606.sNowAdc[6] = AD7606_RESULT();	/* 7· */
	g_tAD7606.sNowAdc[7] = AD7606_RESULT();	/* 8· */
}

/*
*********************************************************************************************************
*		ĺڶʱɼģʽ TIM5ӲʱжжȡADCȫFIFO
*
*
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*	  : AD7606_HasNewData
*	˵: жFIFOǷ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾУ0ʾ
*********************************************************************************************************
*/
uint8_t AD7606_HasNewData(void)
{
	if (g_tAdcFifo.usCount > 0)
	{
		return 1;
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : AD7606_FifoFull
*	˵: жFIFOǷ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾ0ʾδ
*********************************************************************************************************
*/
uint8_t AD7606_FifoFull(void)
{
	return g_tAdcFifo.ucFull;
}

/*
*********************************************************************************************************
*	  : AD7606_ReadFifo
*	˵: FIFOжȡһADCֵ
*	    :  _usReadAdc : ADCıָ
*	  ֵ: 1 ʾOK0ʾ
*********************************************************************************************************
*/
uint8_t AD7606_ReadFifo(uint16_t *_usReadAdc)
{
	if (AD7606_HasNewData())
	{
		*_usReadAdc = g_tAdcFifo.sBuf[g_tAdcFifo.usRead];
		if (++g_tAdcFifo.usRead >= ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usRead = 0;
		}

		DISABLE_INT();
		if (g_tAdcFifo.usCount > 0)
		{
			g_tAdcFifo.usCount--;
		}
		ENABLE_INT();
		return 1;
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : AD7606_StartRecord
*	˵: ʼɼ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StartRecord(uint32_t _ulFreq)
{
	AD7606_StopRecord();

	AD7606_Reset();					/* λӲ */
	AD7606_StartConvst();			/* 1ȫ0 */

	g_tAdcFifo.usRead = 0;			/* ڿTIM2֮ǰ0 */
	g_tAdcFifo.usWrite = 0;
	g_tAdcFifo.usCount = 0;
	g_tAdcFifo.ucFull = 0;

	AD7606_EnterAutoMode(_ulFreq);
}


/*
*********************************************************************************************************
*	  : AD7606_EnterAutoMode
*	˵: ӲԶɼģʽ洢FIFO
*	    :  _ulFreq : ƵʣλHz	1k2k5k10k20K50k100k200k
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_EnterAutoMode(uint32_t _ulFreq)
{
	/* PC6ΪTIM1_CH1ܣռձ50%ķ */
	bsp_SetTIMOutPWM(CONVST_GPIO, CONVST_PIN, CONVST_TIMX,  CONVST_TIMCH, _ulFreq, 5000);
	
	/* PE5, BUSY Ϊжڣ½ش */
	{
		GPIO_InitTypeDef   GPIO_InitStructure;
		
		CONVST_RCC_GPIO_CLK_ENABLE();	/* GPIOʱ */
		__HAL_RCC_SYSCFG_CLK_ENABLE();

		GPIO_InitStructure.Mode = GPIO_MODE_IT_FALLING;	/* ж½ش */
		GPIO_InitStructure.Pull = GPIO_NOPULL;
		GPIO_InitStructure.Speed = GPIO_SPEED_FREQ_LOW;		
		GPIO_InitStructure.Pin = BUSY_PIN;
		HAL_GPIO_Init(BUSY_GPIO, &GPIO_InitStructure);	

		HAL_NVIC_SetPriority(BUSY_IRQn, 2, 0);
		HAL_NVIC_EnableIRQ(BUSY_IRQn);		
	}		
}

/*
*********************************************************************************************************
*	  : AD7606_StopRecord
*	˵: ֹͣɼʱ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_StopRecord(void)
{
	/* PC6 ͵ƽرTIM */
	bsp_SetTIMOutPWM(CONVST_GPIO, CONVST_PIN, CONVST_TIMX,  CONVST_TIMCH, 1000, 10000);
	CONVST_1();					/* תGPIOƽʱΪ */	

	/*  BUSY Ϊжڣ½ش */
	{
		GPIO_InitTypeDef   GPIO_InitStructure;
		
		CONVST_RCC_GPIO_CLK_ENABLE();		/* GPIOʱ */

		/* Configure PC.13 pin as input floating */
		GPIO_InitStructure.Mode = GPIO_MODE_INPUT;
		GPIO_InitStructure.Pull = GPIO_NOPULL;
		GPIO_InitStructure.Pin = CONVST_PIN;
		HAL_GPIO_Init(CONVST_GPIO, &GPIO_InitStructure);	

		HAL_NVIC_DisableIRQ(EXTI9_5_IRQn);		
	}
}

/*
*********************************************************************************************************
*	  : AD7606_ISR
*	˵: ʱɼжϷ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void AD7606_ISR(void)
{
	uint8_t i;

	AD7606_ReadNowAdc();

	for (i = 0; i < 8; i++)
	{
		g_tAdcFifo.sBuf[g_tAdcFifo.usWrite] = g_tAD7606.sNowAdc[i];
		if (++g_tAdcFifo.usWrite >= ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usWrite = 0;
		}
		if (g_tAdcFifo.usCount < ADC_FIFO_SIZE)
		{
			g_tAdcFifo.usCount++;
		}
		else
		{
			g_tAdcFifo.ucFull = 1;		/* FIFO  */
		}
	}
}

/*
*********************************************************************************************************
*	  : EXTI9_5_IRQHandler
*	˵: ⲿжϷڡPE5 / AD7606_BUSY ½жϴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
#ifndef EXTI9_5_ISR_MOVE_OUT		/* bsp.h жУʾƵ stam32h7xx_it.c ظ */
void BUSY_IRQHandler(void)
{
	HAL_GPIO_EXTI_IRQHandler(BUSY_PIN);
}

/*
*********************************************************************************************************
*	  : EXTI9_5_IRQHandler
*	˵: ⲿжϷڡPI6 / AD7606_BUSY ½жϴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if (GPIO_Pin == BUSY_PIN)
	{
		AD7606_ISR();
	}
}

#endif

/*****************************  www.armfly.com (END OF FILE) *********************************/
