/*
*********************************************************************************************************
*
*	ģ : I2Cģ
*	ļ : bsp_i2c_gpio.c
*	     : V1.0
*	˵     : gpioģi2c, STM32F4ϵCPUģ鲻Ӧò֡I2C߻
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

/*
	Ӧ˵
	ڷI2C豸ǰȵ i2c_CheckDevice() I2C豸ǷúGPIO
*/

#include "bsp.h"

/*
	STM32-V7 i2cGPIO:
 		PB6/I2C1_SCL
 		PB9/I2C1_SDA
*/

/* I2CӵGPIO˿, ûֻҪ޸4д뼴ıSCLSDA */
#define I2C_SCL_GPIO	GPIOB			/* ӵSCLʱߵGPIO */
#define I2C_SDA_GPIO	GPIOB			/* ӵSDAߵGPIO */

#define I2C_SCL_PIN		GPIO_PIN_6			/* ӵSCLʱߵGPIO */
#define I2C_SDA_PIN		GPIO_PIN_9			/* ӵSDAߵGPIO */

#define ALL_I2C_GPIO_CLK_ENABLE()	__HAL_RCC_GPIOB_CLK_ENABLE()

/* дSCLSDAĺ */
#define I2C_SCL_1()  I2C_SCL_GPIO->BSRR = I2C_SCL_PIN				/* SCL = 1 */
#define I2C_SCL_0()  I2C_SCL_GPIO->BSRR = ((uint32_t)I2C_SCL_PIN << 16U)				/* SCL = 0 */

#define I2C_SDA_1()  I2C_SDA_GPIO->BSRR = I2C_SDA_PIN				/* SDA = 1 */
#define I2C_SDA_0()  I2C_SDA_GPIO->BSRR = ((uint32_t)I2C_SDA_PIN << 16U)				/* SDA = 0 */


#define I2C_SDA_READ()  ((I2C_SDA_GPIO->IDR & I2C_SDA_PIN) != 0)	/* SDA״̬ */
#define I2C_SCL_READ()  ((I2C_SCL_GPIO->IDR & I2C_SCL_PIN) != 0)	/* SCL״̬ */

/*
*********************************************************************************************************
*	  : bsp_InitI2C
*	˵: I2CߵGPIOģIOķʽʵ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitI2C(void)
{
	GPIO_InitTypeDef gpio_init;

	/* 1GPIOʱ */
	ALL_I2C_GPIO_CLK_ENABLE();
	
	gpio_init.Mode = GPIO_MODE_OUTPUT_OD;	/* ÿ© */
	gpio_init.Pull = GPIO_NOPULL;			/* 費ʹ */
	gpio_init.Speed = GPIO_SPEED_FREQ_LOW;	// GPIO_SPEED_FREQ_HIGH;  /* GPIOٶȵȼ */
	
	gpio_init.Pin = I2C_SCL_PIN;	
	HAL_GPIO_Init(I2C_SCL_GPIO, &gpio_init);	
	
	gpio_init.Pin = I2C_SDA_PIN;	
	HAL_GPIO_Init(I2C_SDA_GPIO, &gpio_init);	

	/* һֹͣź, λI2Cϵ豸ģʽ */
	i2c_Stop();
}

/*
*********************************************************************************************************
*	  : i2c_Delay
*	˵: I2Cλӳ٣400KHz
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void i2c_Delay(void)
{
	/*
		CPUƵ168MHzʱڲFlash, MDK̲Ż̨ʽʾ۲ⲨΡ
		ѭΪ5ʱSCLƵ = 1.78MHz (ʱ: 92ms, дʾ̽ͷϾͶдʧܡʱӽٽ)
		ѭΪ10ʱSCLƵ = 1.1MHz (ʱ: 138ms, ٶ: 118724B/s)
		ѭΪ30ʱSCLƵ = 440KHz SCLߵƽʱ1.0usSCL͵ƽʱ1.2us

		ѡ2.2KŷʱSCLʱԼ0.5usѡ4.7KŷԼ1us

		ʵӦѡ400KHzҵʼ
	*/
	//for (i = 0; i < 30; i++);
	//for (i = 0; i < 60; i++);
	//bsp_DelayUS(2); 229.57KHzʱ
	bsp_DelayUS(2);
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Start(void)
{
	/* SCLߵƽʱSDAһرʾI2Cź */
	I2C_SDA_1();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_0();
	i2c_Delay();
	
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_Start
*	˵: CPUI2Cֹͣź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Stop(void)
{
	/* SCLߵƽʱSDAһرʾI2Cֹͣź */
	I2C_SDA_0();
	i2c_Delay();
	I2C_SCL_1();
	i2c_Delay();
	I2C_SDA_1();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_SendByte
*	˵: CPUI2C豸8bit
*	    :  _ucByte  ȴ͵ֽ
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_SendByte(uint8_t _ucByte)
{
	uint8_t i;

	/* ȷֽڵĸλbit7 */
	for (i = 0; i < 8; i++)
	{
		if (_ucByte & 0x80)
		{
			I2C_SDA_1();
		}
		else
		{
			I2C_SDA_0();
		}
		i2c_Delay();
		I2C_SCL_1();
		i2c_Delay();
		I2C_SCL_0();
		I2C_SCL_0();	/* 2019-03-14 GT811ݴһУ൱ӳټʮns */
		if (i == 7)
		{
			 I2C_SDA_1(); // ͷ
		}
		_ucByte <<= 1;	/* һbit */	
	}
}

/*
*********************************************************************************************************
*	  : i2c_ReadByte
*	˵: CPUI2C豸ȡ8bit
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
uint8_t i2c_ReadByte(void)
{
	uint8_t i;
	uint8_t value;

	/* 1bitΪݵbit7 */
	value = 0;
	for (i = 0; i < 8; i++)
	{
		value <<= 1;
		I2C_SCL_1();
		i2c_Delay();
		if (I2C_SDA_READ())
		{
			value++;
		}
		I2C_SCL_0();
		i2c_Delay();
	}
	return value;
}

/*
*********************************************************************************************************
*	  : i2c_WaitAck
*	˵: CPUһʱӣȡACKӦź
*	    :  
*	  ֵ: 0ʾȷӦ1ʾӦ
*********************************************************************************************************
*/
uint8_t i2c_WaitAck(void)
{
	uint8_t re;

	I2C_SDA_1();	/* CPUͷSDA */
	i2c_Delay();
	I2C_SCL_1();	/* CPUSCL = 1, ʱ᷵ACKӦ */
	i2c_Delay();
	if (I2C_SDA_READ())	/* CPUȡSDA״̬ */
	{
		re = 1;
	}
	else
	{
		re = 0;
	}
	I2C_SCL_0();
	i2c_Delay();
	return re;
}

/*
*********************************************************************************************************
*	  : i2c_Ack
*	˵: CPUһACKź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_Ack(void)
{
	I2C_SDA_0();	/* CPUSDA = 0 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
	I2C_SDA_1();	/* CPUͷSDA */
	
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_NAck
*	˵: CPU1NACKź
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void i2c_NAck(void)
{
	I2C_SDA_1();	/* CPUSDA = 1 */
	i2c_Delay();
	I2C_SCL_1();	/* CPU1ʱ */
	i2c_Delay();
	I2C_SCL_0();
	i2c_Delay();
}

/*
*********************************************************************************************************
*	  : i2c_CheckDevice
*	˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ
*	    :  _Address豸I2Cߵַ
*	  ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽
*********************************************************************************************************
*/
uint8_t i2c_CheckDevice(uint8_t _Address)
{
	uint8_t ucAck;

	if (I2C_SDA_READ() && I2C_SCL_READ())
	{
		i2c_Start();		/* ź */

		/* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
		i2c_SendByte(_Address | I2C_WR);
		ucAck = i2c_WaitAck();	/* 豸ACKӦ */

		i2c_Stop();			/* ֹͣź */

		return ucAck;
	}
	return 1;	/* I2C쳣 */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
