/*
*********************************************************************************************************
*
*	ģ : ңؽģ
*	ļ : bsp_ir_decode.c
*	     : V1.0
*	˵     : ңؽյĺźCPU PB0/TIM3_CH3.  ʹTIM3_CH3ͨ벶
*				Э롣
*
*	޸ļ¼ :
*		汾                ˵
*		V1.0    2014-02-12   armfly  ʽ
*		V1.1	2015-12-09   armfly  CPUƵTIMƵϵ192Mʱ޷ȷ⡣
*
*	Copyright (C), 2015-2020,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

#define IR_REPEAT_SEND_EN		1	/* ʹ */
#define IR_REPEAT_FILTER		10	/* ң108ms , 1ط */

/* GPIO˿ */
#define IRD_CLK_ENABLE() 	__HAL_RCC_GPIOB_CLK_ENABLE()
#define IRD_GPIO			GPIOB
#define IRD_PIN				GPIO_PIN_8

/* PB8/TIM4_CH3  */
#define	IRD_TIMx_IRQHandler		TIM4_IRQHandler
#define TIMx					TIM4
#define TIMx_CHANNEL			TIM_CHANNEL_3
#define TIMx_ACTIVE_CHANNEL 	HAL_TIM_ACTIVE_CHANNEL_3

/* Definition for TIMx's NVIC */
#define TIMx_IRQn				TIM4_IRQn

#define TIMx_CLK_ENABLE()		__HAL_RCC_TIM4_CLK_ENABLE()
#define TIMx_GPIO_AF_TIMx  		GPIO_AF2_TIM4

static TIM_HandleTypeDef    TimHandle_IR;
IRD_T g_tIR;

static void IRD_DecodeNec(uint16_t _width);

/*
*********************************************************************************************************
*	  : bsp_InitIRD
*	˵: STM32GPIO,ںң
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitIRD(void)
{
	GPIO_InitTypeDef gpio_init;
	
	IRD_CLK_ENABLE();
	
	/* DQΪ© */
	gpio_init.Mode = GPIO_MODE_AF_PP;		/* ÿ© */
	gpio_init.Pull = GPIO_NOPULL;			/* 費ʹ */
	gpio_init.Speed = GPIO_SPEED_FREQ_LOW;  /* GPIOٶȵȼ */	
	gpio_init.Pin = IRD_PIN;	
	HAL_GPIO_Init(IRD_GPIO, &gpio_init);	
}

/*
*********************************************************************************************************
*	  : IRD_StartWork
*	˵: TIMʼ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void IRD_StartWork(void)
{
	{
		GPIO_InitTypeDef gpio_init;
		
		IRD_CLK_ENABLE();
		
		/* DQΪ© */
		gpio_init.Mode = GPIO_MODE_AF_PP;		/* ÿ© */
		gpio_init.Pull = GPIO_NOPULL;			/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_VERY_HIGH;  /* GPIOٶȵȼ */
		gpio_init.Alternate = TIMx_GPIO_AF_TIMx;
		gpio_init.Pin = IRD_PIN;	
		HAL_GPIO_Init(IRD_GPIO, &gpio_init);	
	}
  
	{
		TIM_IC_InitTypeDef     sICConfig;
		  
		/* Set TIMx instance */
		TimHandle_IR.Instance = TIMx;

		/* ÷ƵΪ 1680/2 ֵĵλ 10us, Ƚ 
			SystemCoreClock Ƶ. ֵ: 168000000, 180000000,192000000
		*/

		TimHandle_IR.Init.Period            = 0xFFFF;
		TimHandle_IR.Init.Prescaler         = (SystemCoreClock / 100000) / 2;
		TimHandle_IR.Init.ClockDivision     = 0;
		TimHandle_IR.Init.CounterMode       = TIM_COUNTERMODE_UP;
		TimHandle_IR.Init.RepetitionCounter = 0;
		if(HAL_TIM_IC_Init(&TimHandle_IR) != HAL_OK)
		{
			Error_Handler(__FILE__, __LINE__);
		}

		/*##-2- Configure the Input Capture channel ################################*/ 
		/* Configure the Input Capture of channel 2 */
		sICConfig.ICPolarity  = TIM_ICPOLARITY_BOTHEDGE;
		sICConfig.ICSelection = TIM_ICSELECTION_DIRECTTI;
		sICConfig.ICPrescaler = TIM_ICPSC_DIV1;
		sICConfig.ICFilter    = 0;   
		if (HAL_TIM_IC_ConfigChannel(&TimHandle_IR, &sICConfig, TIMx_CHANNEL) != HAL_OK)
		{
			Error_Handler(__FILE__, __LINE__);
		}

		/*##-3- Start the Input Capture in interrupt mode ##########################*/
		if (HAL_TIM_IC_Start_IT(&TimHandle_IR, TIMx_CHANNEL) != HAL_OK)
		{
			Error_Handler(__FILE__, __LINE__);
		}	  
	}
	
	{
		/* TIMx Peripheral clock enable */
		TIMx_CLK_ENABLE();

		HAL_NVIC_SetPriority(TIMx_IRQn, 0, 1);

		/* Enable the TIMx global Interrupt */
		HAL_NVIC_EnableIRQ(TIMx_IRQn);	
	}
	
	g_tIR.LastCapture = 0;	
	g_tIR.Status = 0;
}


/*
*********************************************************************************************************
*	  : IRD_TIMx_IRQHandler
*	˵: TIMжϷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void IRD_TIMx_IRQHandler(void)
{
	HAL_TIM_IRQHandler(&TimHandle_IR);
}

/*
*********************************************************************************************************
*	  : HAL_TIM_IC_CaptureCallback
*	˵: TIMжϷлñв¼
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_TIM_IC_CaptureCallback(TIM_HandleTypeDef *htim)
{
	uint16_t NowCapture;
	uint16_t Width;
	
	if (htim->Channel == TIMx_ACTIVE_CHANNEL)
	{
		NowCapture = HAL_TIM_ReadCapturedValue(htim, TIMx_CHANNEL);

		if (NowCapture >= g_tIR.LastCapture)
		{
			Width = NowCapture - g_tIR.LastCapture;
		}
		else if (NowCapture < g_tIR.LastCapture)	/* ִ󲢷ת */
		{
			Width = ((0xFFFF - g_tIR.LastCapture) + NowCapture);
		}			
		
		if ((g_tIR.Status == 0) && (g_tIR.LastCapture == 0))
		{
			g_tIR.LastCapture = NowCapture;
			return;
		}
				
		g_tIR.LastCapture = NowCapture;	/* 浱ǰ´μֵ */
		
		IRD_DecodeNec(Width);		/*  */		
	}
}

/*
*********************************************************************************************************
*	  : IRD_StopWork
*	˵: ֹͣ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void IRD_StopWork(void)
{
	HAL_TIM_IC_DeInit(&TimHandle_IR);		
	
	HAL_TIM_IC_Stop_IT(&TimHandle_IR, TIMx_CHANNEL);
}

/*
*********************************************************************************************************
*	  : IRD_DecodeNec
*	˵: NECʽʵʱ
*	    : _width ȣλ 10us
*	  ֵ: 
*********************************************************************************************************
*/
static void IRD_DecodeNec(uint16_t _width)
{
	static uint16_t s_LowWidth;
	static uint8_t s_Byte;
	static uint8_t s_Bit;
	uint16_t TotalWitdh;
	
	/* NEC ʽ 5Σ
		1  9ms + 4.5ms
		28λַ  0=1.125ms  1=2.25ms    bit0ȴ
		38λַ  0=1.125ms  1=2.25ms
		48λ      0=1.125ms  1=2.25ms
		58Ϊ뷴  0=1.125ms  1=2.25ms
	*/

loop1:	
	switch (g_tIR.Status)
	{
		case 0:			/* 929 ȴź  7ms - 11ms */
			if ((_width > 700) && (_width < 1100))
			{
				g_tIR.Status = 1;
				s_Byte = 0;
				s_Bit = 0;
			}
			break;

		case 1:			/* 413 жź  3ms - 6ms */
			if ((_width > 313) && (_width < 600))	/*  4.5ms */
			{
				g_tIR.Status = 2;
			}
			else if ((_width > 150) && (_width < 250))	/* 2.25ms */
			{
				#ifdef IR_REPEAT_SEND_EN				
					if (g_tIR.RepeatCount >= IR_REPEAT_FILTER)
					{
						bsp_PutKey(g_tIR.RxBuf[2] + IR_KEY_STRAT);	/*  */
					}
					else
					{
						g_tIR.RepeatCount++;
					}
				#endif
				g_tIR.Status = 0;	/* λ״̬ */
			}
			else
			{
				/* 쳣 */
				g_tIR.Status = 0;	/* λ״̬ */
			}
			break;
		
		case 2:			/* ͵ƽڼ 0.56ms */
			if ((_width > 10) && (_width < 100))
			{		
				g_tIR.Status = 3;
				s_LowWidth = _width;	/* ͵ƽ */
			}
			else	/* 쳣 */
			{
				/* 쳣 */
				g_tIR.Status = 0;	/* λ״̬ */	
				goto loop1;		/* жͬź */
			}
			break;

		case 3:			/* 85+25, 64+157 ʼ32bit */						
			TotalWitdh = s_LowWidth + _width;
			/* 0ĿΪ1.125ms1ĿΪ2.25ms */				
			s_Byte >>= 1;
			if ((TotalWitdh > 92) && (TotalWitdh < 132))
			{
				;					/* bit = 0 */
			}
			else if ((TotalWitdh > 205) && (TotalWitdh < 245))
			{
				s_Byte += 0x80;		/* bit = 1 */
			}	
			else
			{
				/* 쳣 */
				g_tIR.Status = 0;	/* λ״̬ */	
				goto loop1;		/* жͬź */
			}
			
			s_Bit++;
			if (s_Bit == 8)	/* 8λ */
			{
				g_tIR.RxBuf[0] = s_Byte;
				s_Byte = 0;
			}
			else if (s_Bit == 16)	/* 16λ */
			{
				g_tIR.RxBuf[1] = s_Byte;
				s_Byte = 0;
			}
			else if (s_Bit == 24)	/* 24λ */
			{
				g_tIR.RxBuf[2] = s_Byte;
				s_Byte = 0;
			}
			else if (s_Bit == 32)	/* 32λ */
			{
				g_tIR.RxBuf[3] = s_Byte;
								
				if (g_tIR.RxBuf[2] + g_tIR.RxBuf[3] == 255)	/* У */
				{
					bsp_PutKey(g_tIR.RxBuf[2] + IR_KEY_STRAT);	/* ֵKEY FIFO */
					
					g_tIR.RepeatCount = 0;	/* ط */										
				}
				
				g_tIR.Status = 0;	/* ȴһ */
				break;
			}
			g_tIR.Status = 2;	/* һbit */
			break;						
	}
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
