/*
*********************************************************************************************************
*
*	ģ : W25Q256 QSPIģ
*	ļ : bsp_qspi_w25q256.c
*	     : V1.0
*	˵     : ʹCPUQSPIFLASHṩĶд4߷ʽMDMA
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2019-02-12  armfly  ʽ
*
*	Copyright (C), 2019-2030,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"



/* 
    STM32-V7

	PG6/QUADSPI_BK1_NCS AF10
	PF10/QUADSPI_CLK	AF9
	PF8/QUADSPI_BK1_IO0 AF10
	PF9/QUADSPI_BK1_IO1 AF10
	PF7/QUADSPI_BK1_IO2 AF9
	PF6/QUADSPI_BK1_IO3 AF9

	W25Q256JV512飬ÿ16ÿSector16ҳÿҳ256ֽڣ32MB
*/

/* QSPIźʱú궨 */
#define QSPI_CLK_ENABLE()              __HAL_RCC_QSPI_CLK_ENABLE()
#define QSPI_CLK_DISABLE()             __HAL_RCC_QSPI_CLK_DISABLE()
#define QSPI_CS_GPIO_CLK_ENABLE()      __HAL_RCC_GPIOG_CLK_ENABLE()
#define QSPI_CLK_GPIO_CLK_ENABLE()     __HAL_RCC_GPIOF_CLK_ENABLE()
#define QSPI_BK1_D0_GPIO_CLK_ENABLE()  __HAL_RCC_GPIOF_CLK_ENABLE()
#define QSPI_BK1_D1_GPIO_CLK_ENABLE()  __HAL_RCC_GPIOF_CLK_ENABLE()
#define QSPI_BK1_D2_GPIO_CLK_ENABLE()  __HAL_RCC_GPIOF_CLK_ENABLE()
#define QSPI_BK1_D3_GPIO_CLK_ENABLE()  __HAL_RCC_GPIOF_CLK_ENABLE()

#define QSPI_MDMA_CLK_ENABLE()         __HAL_RCC_MDMA_CLK_ENABLE()
#define QSPI_FORCE_RESET()             __HAL_RCC_QSPI_FORCE_RESET()
#define QSPI_RELEASE_RESET()           __HAL_RCC_QSPI_RELEASE_RESET()

#define QSPI_CS_PIN                    GPIO_PIN_6
#define QSPI_CS_GPIO_PORT              GPIOG

#define QSPI_CLK_PIN                   GPIO_PIN_10
#define QSPI_CLK_GPIO_PORT             GPIOF

#define QSPI_BK1_D0_PIN                GPIO_PIN_8
#define QSPI_BK1_D0_GPIO_PORT          GPIOF

#define QSPI_BK1_D1_PIN                GPIO_PIN_9
#define QSPI_BK1_D1_GPIO_PORT          GPIOF

#define QSPI_BK1_D2_PIN                GPIO_PIN_7
#define QSPI_BK1_D2_GPIO_PORT          GPIOF

#define QSPI_BK1_D3_PIN                GPIO_PIN_6
#define QSPI_BK1_D3_GPIO_PORT          GPIOF


/* ļõȫֱ */
static MDMA_HandleTypeDef hmdma;
static QSPI_HandleTypeDef 	QSPIHandle;
static __IO uint8_t CmdCplt, RxCplt, TxCplt, StatusMatch, TimeOut;

/* ļõĺ */
static void QSPI_WriteEnable(QSPI_HandleTypeDef *hqspi);
static void QSPI_AutoPollingMemReady(QSPI_HandleTypeDef *hqspi);


/*
*********************************************************************************************************
*	  : bsp_InitQSPI_W25Q256
*	˵: QSPI FlashӲʼû
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitQSPI_W25Q256(void)
{
	/* λQSPI */
	QSPIHandle.Instance = QUADSPI;
	if (HAL_QSPI_DeInit(&QSPIHandle) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
	
	/* ʱٶȣQSPI clock = 200MHz / (ClockPrescaler+1) = 100MHz */
	QSPIHandle.Init.ClockPrescaler  = 1;  
	
	/* FIFOֵΧ1 - 32 */
	QSPIHandle.Init.FifoThreshold   = 32; 
	
	/* 
		QUADSPIFLASHźźCLKڲŶFLASHݲ
		ⲿźӳʱƳݲ
	*/
	QSPIHandle.Init.SampleShifting  = QSPI_SAMPLE_SHIFTING_HALFCYCLE; 
	
	/*FlashС2^(FlashSize + 1) = 2^25 = 32MB */
	QSPIHandle.Init.FlashSize       = QSPI_FLASH_SIZE - 1; 
	
	/* ֮CSƬѡٱ1ʱڵĸߵƽ */
	QSPIHandle.Init.ChipSelectHighTime = QSPI_CS_HIGH_TIME_1_CYCLE;
	
	/*
	   MODE0: ʾƬѡźſڼ䣬CLKʱźǵ͵ƽ
	   MODE3: ʾƬѡźſڼ䣬CLKʱźǸߵƽ
	*/
	QSPIHandle.Init.ClockMode = QSPI_CLOCK_MODE_0;
	
	/* QSPIBANKʹõBANK1 */
	QSPIHandle.Init.FlashID   = QSPI_FLASH_ID_1;
	
	/* V7ʹBANK1ǽֹ˫BANK */
	QSPIHandle.Init.DualFlash = QSPI_DUALFLASH_DISABLE;

	/* ʼQSPI */
	if (HAL_QSPI_Init(&QSPIHandle) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}	
}	

/*
*********************************************************************************************************
*	  : HAL_QSPI_MspInit
*	˵: QSPIײʼHAL_QSPI_Initõĵײ㺯
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_QSPI_MspInit(QSPI_HandleTypeDef *hqspi)
{
	GPIO_InitTypeDef GPIO_InitStruct;

	/* ʹQPSIʱ  */
	QSPI_CLK_ENABLE();
	
	/* λʱӽӿ */
	QSPI_FORCE_RESET();
	QSPI_RELEASE_RESET();
	
	/* ʹGPIOʱ */
	QSPI_CS_GPIO_CLK_ENABLE();
	QSPI_CLK_GPIO_CLK_ENABLE();
	QSPI_BK1_D0_GPIO_CLK_ENABLE();
	QSPI_BK1_D1_GPIO_CLK_ENABLE();
	QSPI_BK1_D2_GPIO_CLK_ENABLE();
	QSPI_BK1_D3_GPIO_CLK_ENABLE(); 

	/* QSPI CS GPIO  */
	GPIO_InitStruct.Pin       = QSPI_CS_PIN;
	GPIO_InitStruct.Mode      = GPIO_MODE_AF_PP;
	GPIO_InitStruct.Pull      = GPIO_PULLUP;
	GPIO_InitStruct.Speed     = GPIO_SPEED_FREQ_VERY_HIGH;
	GPIO_InitStruct.Alternate = GPIO_AF10_QUADSPI;
	HAL_GPIO_Init(QSPI_CS_GPIO_PORT, &GPIO_InitStruct);
	
	/* QSPI CLK GPIO  */
	GPIO_InitStruct.Pin       = QSPI_CLK_PIN;
	GPIO_InitStruct.Pull      = GPIO_NOPULL;
	GPIO_InitStruct.Alternate = GPIO_AF9_QUADSPI;
	HAL_GPIO_Init(QSPI_CLK_GPIO_PORT, &GPIO_InitStruct);

	/* QSPI D0 GPIO pin  */
	GPIO_InitStruct.Pin       = QSPI_BK1_D0_PIN;
	GPIO_InitStruct.Alternate = GPIO_AF10_QUADSPI;
	HAL_GPIO_Init(QSPI_BK1_D0_GPIO_PORT, &GPIO_InitStruct);

	/* QSPI D1 GPIO  */
	GPIO_InitStruct.Pin       = QSPI_BK1_D1_PIN;
	GPIO_InitStruct.Alternate = GPIO_AF10_QUADSPI;
	HAL_GPIO_Init(QSPI_BK1_D1_GPIO_PORT, &GPIO_InitStruct);

	/* QSPI D2 GPIO  */
	GPIO_InitStruct.Pin       = QSPI_BK1_D2_PIN;
	GPIO_InitStruct.Alternate = GPIO_AF9_QUADSPI;
	HAL_GPIO_Init(QSPI_BK1_D2_GPIO_PORT, &GPIO_InitStruct);

	/* QSPI D3 GPIO  */
	GPIO_InitStruct.Pin       = QSPI_BK1_D3_PIN;
	GPIO_InitStruct.Alternate = GPIO_AF9_QUADSPI;
	HAL_GPIO_Init(QSPI_BK1_D3_GPIO_PORT, &GPIO_InitStruct);

	/* ʹQSPIж */
	HAL_NVIC_SetPriority(QUADSPI_IRQn, 0x0F, 0);
	HAL_NVIC_EnableIRQ(QUADSPI_IRQn);
	
	/* MDMAʱ */
	QSPI_MDMA_CLK_ENABLE();

	hmdma.Instance = MDMA_Channel1;                         /* ʹMDMAͨ1 */
	hmdma.Init.Request = MDMA_REQUEST_QUADSPI_FIFO_TH;      /* QSPIFIFOֵж */
	hmdma.Init.TransferTriggerMode = MDMA_BUFFER_TRANSFER;  /* ʹMDMAbuffer */
	hmdma.Init.Priority = MDMA_PRIORITY_HIGH;               /* ȼ */
	hmdma.Init.Endianness = MDMA_LITTLE_ENDIANNESS_PRESERVE;/* С˸ʽ */
	hmdma.Init.SourceInc = MDMA_SRC_INC_BYTE;               /* Դַֽڵ */
	hmdma.Init.DestinationInc = MDMA_DEST_INC_DISABLE;      /* ĿĵַЧ */
	hmdma.Init.SourceDataSize = MDMA_SRC_DATASIZE_BYTE;     /* Դַݿֽ */
	hmdma.Init.DestDataSize = MDMA_DEST_DATASIZE_BYTE;      /* Ŀĵַݿֽ */
	hmdma.Init.DataAlignment = MDMA_DATAALIGN_PACKENABLE;   /* СˣҶ */
	hmdma.Init.BufferTransferLength = 128;                  /* ÿδ128ֽ */
	hmdma.Init.SourceBurst = MDMA_SOURCE_BURST_SINGLE;      /* Դݵδ */
	hmdma.Init.DestBurst = MDMA_DEST_BURST_SINGLE;          /* Ŀݵδ */
	
	hmdma.Init.SourceBlockAddressOffset = 0;                /* block䣬bufferò */
	hmdma.Init.DestBlockAddressOffset = 0;                  /* block䣬bufferò */

	/* MDMAQSPI  */
	__HAL_LINKDMA(hqspi, hmdma, hmdma);

	/* ȸλȻMDMA */
	HAL_MDMA_DeInit(&hmdma);  
	HAL_MDMA_Init(&hmdma);

	/* ʹMDMAжϣȼ */
	HAL_NVIC_SetPriority(MDMA_IRQn, 0x02, 0);
	HAL_NVIC_EnableIRQ(MDMA_IRQn);
}

/*
*********************************************************************************************************
*	  : HAL_QSPI_MspDeInit
*	˵: QSPIײ㸴λHAL_QSPI_Initõĵײ㺯
*	    : hqspi QSPI_HandleTypeDef;
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_QSPI_MspDeInit(QSPI_HandleTypeDef *hqspi)
{
	/* λQSPI */
	HAL_GPIO_DeInit(QSPI_CS_GPIO_PORT, QSPI_CS_PIN);
	HAL_GPIO_DeInit(QSPI_CLK_GPIO_PORT, QSPI_CLK_PIN);
	HAL_GPIO_DeInit(QSPI_BK1_D0_GPIO_PORT, QSPI_BK1_D0_PIN);
	HAL_GPIO_DeInit(QSPI_BK1_D1_GPIO_PORT, QSPI_BK1_D1_PIN);
	HAL_GPIO_DeInit(QSPI_BK1_D2_GPIO_PORT, QSPI_BK1_D2_PIN);
	HAL_GPIO_DeInit(QSPI_BK1_D3_GPIO_PORT, QSPI_BK1_D3_PIN);

	/* λQSPI */
	QSPI_FORCE_RESET();
	QSPI_RELEASE_RESET();

	/* رQSPIʱ */
	QSPI_CLK_DISABLE();
}

/*
*********************************************************************************************************
*	  : sf_EraseSector
*	˵: ָС4KB
*	    : _uiSectorAddr : ַ4KBΪλĵַ04096, 8192ȣ
*	  ֵ: 
*********************************************************************************************************
*/
void QSPI_EraseSector(uint32_t address)
{
	QSPI_CommandTypeDef sCommand={0};

	/* ɱ־ */	
	CmdCplt = 0;

	/* дʹ */
	QSPI_WriteEnable(&QSPIHandle);	

	/*  */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    /* 1߷ʽָ */
	sCommand.AddressSize       = QSPI_ADDRESS_32_BITS;       /* 32λַ */
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  /* ޽ֽ */
	sCommand.DdrMode           = QSPI_DDR_MODE_DISABLE;      /* W25Q256JV֧DDR */
	sCommand.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  /* DDRģʽӳ */
	sCommand.SIOOMode          = QSPI_SIOO_INST_EVERY_CMD;	 /* ÿδ䶼ָ */	
	
	/*  */
	sCommand.Instruction = SUBSECTOR_ERASE_4_BYTE_ADDR_CMD;   /* 32bitַʽС4KB*/       
	sCommand.AddressMode = QSPI_ADDRESS_1_LINE;  /* ַ1߷ʽ */       
	sCommand.Address     = address;              /* ׵ַ֤4KB */    
	sCommand.DataMode    = QSPI_DATA_NONE;       /* 跢 */  
	sCommand.DummyCycles = 0;                    /*  */  

	if (HAL_QSPI_Command_IT(&QSPIHandle, &sCommand) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
	
	/* ȴ */
	while(CmdCplt == 0);
	CmdCplt = 0;
	
	/* ȴ̽ */
	StatusMatch = 0;
	QSPI_AutoPollingMemReady(&QSPIHandle);	
	while(StatusMatch == 0);
	StatusMatch = 0;
}

/*
*********************************************************************************************************
*	  : QSPI_WriteBuffer
*	˵: ҳ̣ҳС256ֽڣҳд
*	    : _pBuf : Դ
*			  _uiWrAddr Ŀ׵ַҳ׵ַ0 256, 512ȡ
*			  _usSize ݸܳҳСΧ1 - 256
*	  ֵ: 1:ɹ 0ʧ
*********************************************************************************************************
*/
uint8_t QSPI_WriteBuffer(uint8_t *_pBuf, uint32_t _uiWriteAddr, uint16_t _usWriteSize)
{
	QSPI_CommandTypeDef sCommand={0};
	
	/* ڵȴɱ־ */
	TxCplt = 0;

	/* дʹ */
	QSPI_WriteEnable(&QSPIHandle);	
	
	/*  */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    /* 1߷ʽָ */
	sCommand.AddressSize       = QSPI_ADDRESS_32_BITS;       /* 32λַ */
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  /* ޽ֽ */
	sCommand.DdrMode           = QSPI_DDR_MODE_DISABLE;      /* W25Q256JV֧DDR */
	sCommand.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  /* DDRģʽӳ */
	sCommand.SIOOMode          = QSPI_SIOO_INST_ONLY_FIRST_CMD;	 /* һ */	
	
	/* д */
	sCommand.Instruction = QUAD_IN_FAST_PROG_4_BYTE_ADDR_CMD; /* 32bitַ4߿д */
	sCommand.DummyCycles = 0;                    /* Ҫ */
	sCommand.AddressMode = QSPI_ADDRESS_1_LINE; /* 4ߵַʽ */
	sCommand.DataMode    = QSPI_DATA_4_LINES;    /* 4ݷʽ */
	sCommand.NbData      = _usWriteSize;         /* дݴС */   
	sCommand.Address     = _uiWriteAddr;         /* дַ */
	
	if (HAL_QSPI_Command(&QSPIHandle, &sCommand, HAL_QPSI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
	
	/* MDMA */
	if (HAL_QSPI_Transmit_DMA(&QSPIHandle, _pBuf) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
	
	/* ȴݷ */
	while(TxCplt == 0);
	TxCplt = 0;
	
	/* ȴFlashҳ */
	StatusMatch = 0;
	QSPI_AutoPollingMemReady(&QSPIHandle);	
	while(StatusMatch == 0);
	StatusMatch = 0;	
	
	return 1;
}

/*
*********************************************************************************************************
*	  : QSPI_ReadBuffer
*	˵: ȡֽڣֽڸܳоƬ
*	    : _pBuf : Դ
*			  _uiReadAddr ʼַ
*			  _usSize ݸ, ԴPAGE_SIZE, ǲܳоƬ
*	  ֵ: 
*********************************************************************************************************
*/
void QSPI_ReadBuffer(uint8_t * _pBuf, uint32_t _uiReadAddr, uint32_t _uiSize)
{
	
	QSPI_CommandTypeDef sCommand = {0};
	
	/* ڵȴɱ־ */
	RxCplt = 0;
	
	/*  */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    	/* 1߷ʽָ */
	sCommand.AddressSize       = QSPI_ADDRESS_32_BITS;      	/* 32λַ */
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  	/* ޽ֽ */
	sCommand.DdrMode           = QSPI_DDR_MODE_DISABLE;      	/* W25Q256JV֧DDR */
	sCommand.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  	/* DDRģʽӳ */
	sCommand.SIOOMode          = QSPI_SIOO_INST_EVERY_CMD;		/* ÿδҪָ */	
 
	/* ȡ */
	sCommand.Instruction = QUAD_INOUT_FAST_READ_4_BYTE_ADDR_CMD; /* 32bitַ4߿ٶȡ */
	sCommand.DummyCycles = 6;                    /*  */
	sCommand.AddressMode = QSPI_ADDRESS_4_LINES; /* 4ߵַ */
	sCommand.DataMode    = QSPI_DATA_4_LINES;    /* 4 */ 
	sCommand.NbData      = _uiSize;              /* ȡݴС */ 
	sCommand.Address     = _uiReadAddr;          /* ȡݵʼַ */ 
	
	if (HAL_QSPI_Command(&QSPIHandle, &sCommand, HAL_QPSI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}

	/* MDMAʽȡ */
	if (HAL_QSPI_Receive_DMA(&QSPIHandle, _pBuf) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}	
	
	/* Ƚ */
	while(RxCplt == 0);
	RxCplt = 0;
}

/*
*********************************************************************************************************
*	  : QSPI_WriteEnable
*	˵: дʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
static void QSPI_WriteEnable(QSPI_HandleTypeDef *hqspi)
{
	QSPI_CommandTypeDef     sCommand = {0};
	
	/*  */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    /* 1߷ʽָ */
	sCommand.AddressSize       = QSPI_ADDRESS_32_BITS;       /* 32λַ */
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  /* ޽ֽ */
	sCommand.DdrMode           = QSPI_DDR_MODE_DISABLE;      /* W25Q256JV֧DDR */
	sCommand.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  /* DDRģʽӳ */
	sCommand.SIOOMode          = QSPI_SIOO_INST_EVERY_CMD;	 /* ÿδ䶼ָ */
	
	/* дʹ */
	sCommand.Instruction       = WRITE_ENABLE_CMD;  /* дʹָ */
	sCommand.AddressMode       = QSPI_ADDRESS_NONE; /* ַ */
	sCommand.DataMode          = QSPI_DATA_NONE;    /*  */
	sCommand.DummyCycles       = 0;                 /*   */

	if (HAL_QSPI_Command(&QSPIHandle, &sCommand, HAL_QPSI_TIMEOUT_DEFAULT_VALUE) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
	
//	/* ȴдʹ */
//	StatusMatch = 0;
//	QSPI_AutoPollingMemReady(&QSPIHandle);	
//	while(StatusMatch == 0);
//	StatusMatch = 0;	
}

/*
*********************************************************************************************************
*	  : QSPI_AutoPollingMemReady
*	˵: ȴQSPI FlashҪFlashҳʱʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
static void QSPI_AutoPollingMemReady(QSPI_HandleTypeDef *hqspi)
{
	QSPI_CommandTypeDef     sCommand = {0};
	QSPI_AutoPollingTypeDef sConfig = {0};

	
	/*  */
	sCommand.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    /* 1߷ʽָ */
	sCommand.AddressSize       = QSPI_ADDRESS_32_BITS;       /* 32λַ */
	sCommand.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  /* ޽ֽ */
	sCommand.DdrMode           = QSPI_DDR_MODE_DISABLE;      /* W25Q256JV֧DDR */
	sCommand.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  /* DDRģʽӳ */
	sCommand.SIOOMode          = QSPI_SIOO_INST_EVERY_CMD;	 /* ÿδ䶼ָ */
	
	/* ȡ״̬*/
	sCommand.Instruction       = READ_STATUS_REG_CMD; /* ȡ״̬ */
	sCommand.AddressMode       = QSPI_ADDRESS_NONE;   /* ַ */
	sCommand.DataMode          = QSPI_DATA_1_LINE;    /* 1 */
	sCommand.DummyCycles       = 0;                   /*  */

	/* λõbit0ƥλȴbit0Ϊ0ϲѯ״̬Ĵbit0ȴΪ0 */
	sConfig.Mask            = 0x01;
	sConfig.Match           = 0x00;
	sConfig.MatchMode       = QSPI_MATCH_MODE_AND;
	sConfig.StatusBytesSize = 1;
	sConfig.Interval        = 0x10;
	sConfig.AutomaticStop   = QSPI_AUTOMATIC_STOP_ENABLE;

	if (HAL_QSPI_AutoPolling_IT(&QSPIHandle, &sCommand, &sConfig) != HAL_OK)
	{
		Error_Handler(__FILE__, __LINE__);
	}
}

/*
*********************************************************************************************************
*	  : sf_ReadID
*	˵: ȡID
*	    : 
*	  ֵ: 32bitID (8bit0ЧIDλΪ24bit
*********************************************************************************************************
*/
uint32_t QSPI_ReadID(void)
{
	uint32_t uiID;
	QSPI_CommandTypeDef s_command = {0};
	uint8_t buf[3];

	/*  */
	s_command.InstructionMode   = QSPI_INSTRUCTION_1_LINE;    /* 1߷ʽָ */
	s_command.AddressSize       = QSPI_ADDRESS_32_BITS;       /* 32λַ */
	s_command.AlternateByteMode = QSPI_ALTERNATE_BYTES_NONE;  /* ޽ֽ */
	s_command.DdrMode           = QSPI_DDR_MODE_DISABLE;      /* W25Q256JV֧DDR */
	s_command.DdrHoldHalfCycle  = QSPI_DDR_HHC_ANALOG_DELAY;  /* DDRģʽӳ */
	s_command.SIOOMode          = QSPI_SIOO_INST_EVERY_CMD;	  /* ÿδ䶼ָ */
	
	/* ȡJEDEC ID */
	s_command.Instruction = READ_ID_CMD2;         /* ȡID */
	s_command.AddressMode = QSPI_ADDRESS_NONE;    /* 1ߵַ */
	s_command.DataMode = QSPI_DATA_1_LINE;        /* 1ߵַ */
	s_command.DummyCycles = 0;                    /* ޿ */
	s_command.NbData = 3;                         /* ȡ */

	if (HAL_QSPI_Command(&QSPIHandle, &s_command, HAL_QPSI_TIMEOUT_DEFAULT_VALUE) != HAL_OK) 
	{
		ERROR_HANDLER();
	}

	if (HAL_QSPI_Receive(&QSPIHandle, buf, HAL_QPSI_TIMEOUT_DEFAULT_VALUE) != HAL_OK) 
	{
		ERROR_HANDLER();
	}

	uiID = (buf[0] << 16) | (buf[1] << 8 ) | buf[2];

	return uiID;
}

/*
*********************************************************************************************************
*	  : HAL_QSPI_CmdCpltCallback
*	˵: QSPIжϵĻصFlashQSPI_EraseSectorҪʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_QSPI_CmdCpltCallback(QSPI_HandleTypeDef *hqspi)
{
	CmdCplt++;
}

/*
*********************************************************************************************************
*	  : HAL_QSPI_RxCpltCallback
*	˵: QSPIжϵĻصFlashQSPI_ReadBufferҪʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_QSPI_RxCpltCallback(QSPI_HandleTypeDef *hqspi)
{
	RxCplt++;
}

/*
*********************************************************************************************************
*	  : HAL_QSPI_TxCpltCallback
*	˵: QSPIжϵĻصFlashдQSPI_ReadBufferҪʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
 void HAL_QSPI_TxCpltCallback(QSPI_HandleTypeDef *hqspi)
{
	TxCplt++; 
}

/*
*********************************************************************************************************
*	  : HAL_QSPI_StatusMatchCallback
*	˵: QSPIжϵĻصFlash״̬ѯQSPI_AutoPollingMemReadyʹ
*	    : hqspi  QSPI_HandleTypeDef
*	  ֵ: 
*********************************************************************************************************
*/
void HAL_QSPI_StatusMatchCallback(QSPI_HandleTypeDef *hqspi)
{
	StatusMatch++;
}

/*
*********************************************************************************************************
*	  : QUADSPI_IRQHandler
*	˵: QSPIжϷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void QUADSPI_IRQHandler(void)
{
	HAL_QSPI_IRQHandler(&QSPIHandle);
}

/*
*********************************************************************************************************
*	  : MDMA_IRQHandler
*	˵: MDMAжϷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MDMA_IRQHandler(void)
{
	HAL_MDMA_IRQHandler(QSPIHandle.hmdma);
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
