/*
*********************************************************************************************************
*
*	ģ : LED-485-XXXϵܵ
*	ļ : bsp_rs485_led.c
*	     : V1.0
*	˵     : RS485 LEDʾ ʹ bsp_modbus.c ļ
*			  ͺ: LED-485-043	 λ0.4
*				    LED-485-034  λ0.3
*				    LED-485-083  λ0.8
*				    LED-485-054  λ0.56
*
*			  ֧ASCIIЭ  Modbus RTUЭ顣ͨ485ָл
*
*	Copyright (C), 2014-2015,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/* RTU Ӧ */
#define RSP_OK				0		/* ɹ */
#define RSP_ERR_CMD			0x01	/* ֵ֧Ĺ */
#define RSP_ERR_REG_ADDR	0x02	/* Ĵַ */
#define RSP_ERR_VALUE		0x03	/* ֵ */
#define RSP_ERR_WRITE		0x04	/* дʧ */

static void MODH_RxTimeOut(void);
static uint8_t g_rtu_timeout = 0;

MODH_T g_tModH;

extern void MODBUS_AnalyzeApp(void);

/*
*********************************************************************************************************
*	  : MODH_SendWithCRC
*	˵: һ, Զ׷2ֽCRC
*	    : g_tModH.TxBuf : 
*			  g_tModH.TxLen : ݳȣCRC
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_SendWithCRC(void)
{
	uint16_t crc;

	crc = CRC16_Modbus(g_tModH.TxBuf, g_tModH.TxLen);
	g_tModH.TxBuf[g_tModH.TxLen++] = crc >> 8;
	g_tModH.TxBuf[g_tModH.TxLen++] = crc;
	RS485_SendBuf(g_tModH.TxBuf, g_tModH.TxLen);
}

/*
*********************************************************************************************************
*	  : MODH_Send06H
*	˵: 06HָдһĴ
*	    : _RS485Addr : 485ַ
*			  _RegAddr : Ĵַ
*			  _RegValue : Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send06H(uint8_t _RS485Addr, uint16_t _RegAddr, uint16_t _RegValue)
{
	g_tModH.TxLen = 0;
	g_tModH.TxBuf[g_tModH.TxLen++] = _RS485Addr;			/* 485ַ */
	g_tModH.TxBuf[g_tModH.TxLen++] = 0x06;			/*  */
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegAddr >> 8;		/* Ĵַ*/
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegAddr;
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegValue >> 8;	/* Ĵֵ */
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegValue;	
	MODH_SendWithCRC();
	g_tModH.fAckOK = 0;
}

/*
*********************************************************************************************************
*	  : MODH_Send06H
*	˵: 06HָдһĴ
*	    : _RS485Addr : 485ַ
*			  _RegAddr : Ĵʼַ
*			  _RegNum : Ĵ
*			  _RegValue : Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Send10H(uint8_t _RS485Addr, uint16_t _RegAddr, uint16_t _RegNum, uint16_t *_RegValue)
{
	uint8_t i;
	
	g_tModH.TxLen = 0;
	g_tModH.TxBuf[g_tModH.TxLen++] = _RS485Addr;			/* 485ַ */
	g_tModH.TxBuf[g_tModH.TxLen++] = 0x10;			/*  */
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegAddr >> 8;	/* Ĵʼַ*/
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegAddr;
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegNum >> 8;	/* Ĵ */
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegNum;	
	g_tModH.TxBuf[g_tModH.TxLen++] = _RegNum * 2;	/* ֽ */
	for (i = 0; i < _RegNum; i++)
	{
		g_tModH.TxBuf[g_tModH.TxLen++] = _RegValue[i] >> 8;
		g_tModH.TxBuf[g_tModH.TxLen++] = _RegValue[i];
	}
	MODH_SendWithCRC();
	g_tModH.fAckOK = 0;
}

/*
*********************************************************************************************************
*	  : MODH_ReciveNew
*	˵: ڽжϷñյһֽʱִһαMODBUS HOST
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_ReciveNew(uint8_t _byte)
{
	/*
		3.5ַʱֻRTUģʽ棬ΪRTUģʽûпʼͽ
		ݰֻ֮ܿʱ֣ModbusڲͬĲ£ʱǲһģ
		Ծ3.5ַʱ䣬ʸߣʱСʵͣʱӦʹ

        	ʱ3.5ַ(ms)
        1200	29.16666667
        2400	14.58333333
        4800	7.291666667
        
        ----- ¶ȡ4ms ----
        
        9600	3.645833333
        19200	1.822916667
        38400	0.911458333
        57600	0.607638889
        115200	0.303819444
        
		const uint32_t TimeOut[] = {1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200};
    	const uint8_t TimeOut[] = {30, 15, 8, 4, 4, 4, 4, 4};
	*/
	uint32_t timeout;

	g_rtu_timeout = 0;
	
	if (g_tModH.Baud >= 9600)
	{
		timeout = 4000;		/* 4000us */
	}
	else
	{
		timeout =  35000000 / g_tModH.Baud;	/* 㳬ʱʱ䣬λus */
	}

	/* H743ִ֧ڿжϣLINE TIMEOUTжʵ ʱ. ˴Ż */
	/* Ӳʱжϣʱus ʱ4Modbus */
	bsp_StartHardTimer(1, timeout, (void *)MODH_RxTimeOut);
	
	if (g_tModH.RxCount < MODH_RX_SIZE)
	{
		g_tModH.RxBuf[g_tModH.RxCount++] = _byte;
	}
}

/*
*********************************************************************************************************
*	  : MODH_Poll
*	˵: ݰ. á
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void MODH_Poll(void)
{
	uint16_t crc1;

	if (g_rtu_timeout == 0)
	{
		/* ûгʱաҪ g_tModH.RxCount */
		return;
	}

	/* յ
		05 06 00 88 04 57 3B70 (8 ֽ)
			05    :  ĺվ
			06    :  ָ
			00 88 :  ʾĴ
			04 57 :  ,,,ת 10  1111.λǰ,
			3B70  :  ֽ CRC 	05 57У
	*/
	g_rtu_timeout = 0;

	if (g_tModH.RxCount < 4)
	{
		goto err_ret;
	}

	/* CRCУ */
	crc1 = CRC16_Modbus(g_tModH.RxBuf, g_tModH.RxCount);
	if (crc1 != 0)
	{
		/* յݸƵһȴAPPȡ */
		memcpy(g_tModH.AppRxBuf, g_tModH.RxBuf, g_tModH.RxCount);
		g_tModH.AppRxCount = g_tModH.RxCount;		
		bsp_PutKey(MSG_485_RX_NOT_RTU);		/* ðFIFOһյ485֡Ϣ */
		goto err_ret;
	}
	else
	{
		/* յݸƵһȴAPPȡ */
		memcpy(g_tModH.AppRxBuf, g_tModH.RxBuf, g_tModH.RxCount);
		g_tModH.AppRxCount = g_tModH.RxCount;
		bsp_PutKey(MSG_485_RX_RTU);		/* ðFIFOһյ485֡Ϣ */
	}
err_ret:
	g_tModH.RxCount = 0;	/* ´֡ͬ */
}

/*
*********************************************************************************************************
*	  : MODH_RxTimeOut
*	˵: 3.5ַʱִб ȫֱ g_rtu_timeout = 1; ֪ͨʼ롣
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void MODH_RxTimeOut(void)
{
	g_rtu_timeout = 1;
}

/*
*********************************************************************************************************
*	  : LED485_TestOk
*	˵: Ӧ. ܻӦOK ҪлASCIIЭ顣
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_TestOk(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,01&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_ReadModel
*	˵: ȡͺ. ҪлASCIIЭ顣 ֻǷָ MSG_485_RX Ϣ
*			  
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_ReadModel(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,02&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_ReadVersion
*	˵: ȡܹ̼汾. ҪлASCIIЭ顣 ֻǷָ MSG_485_RX Ϣ
*			  
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_ReadVersion(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,03&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_ReadBright
*	˵: ȡȲҪлASCIIЭ顣 ֻǷָ MSG_485_RX Ϣ
*			  
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_ReadBright(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,04&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_SetBrightA
*	˵: LEDܵ ASCIIЭ)
*	    : _addr : ӻ485ַ
*			  _bright : ֵ 0 - 7
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_SetBrightA(uint8_t _addr, uint8_t _bright)
{
	char buf[10];

	sprintf(buf, "$%03d,%d%%", _addr, _bright);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_ModifyAddrA
*	˵: ޸LEDܵĵַ. ASCIIЭ)
*	    : _addr : ӻ485ַ
*			  _NewAddr : µַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_ModifyAddrA(uint8_t _addr, uint8_t _NewAddr)
{
	char buf[10];

	sprintf(buf, "$%03d,%03d@", _addr, _NewAddr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_DispNumberA
*	˵: ʾ1.  ʹASCIIЭ顣
*	    : _addr : ӻ485ַ
*			  _iNumber : òʾ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_DispNumberA(uint8_t _addr, int16_t _iNumber)
{
	char buf[16];

	sprintf(buf, "$%03d,%3d#", _addr, _iNumber);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_DispStrA
*	˵: ʾ1ASCIIַ ʹASCIIЭ顣
*	    : _addr : ӻ485ַ
*			  _iNumber : òʾ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_DispStrA(uint8_t _addr, char *_str)
{
	char buf[16];

	sprintf(buf, "$%03d,%s#", _addr, _str);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_SetProtRTU
*	˵: ôӻͨЭΪ Modbus RTU
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_SetProtRTU(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,81&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_SetProtAscii
*	˵: ôӻͨЭΪ ASCII
*	    : _addr : ӻ485ַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_SetProtAscii(uint8_t _addr)
{
	char buf[10];

	sprintf(buf, "$%03d,80&", _addr);
	RS485_SendStr(buf);
}

/*
*********************************************************************************************************
*	  : LED485_DispNumber
*	˵: ʾ1. ȴӦ
*	    : _addr : ӻ485ַ
*			  _iNumber : òʾ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_DispNumber(uint8_t _addr, int16_t _iNumber)
{
	MODH_Send06H(_addr, 0x0088, _iNumber);
}

/*
*********************************************************************************************************
*	  : LED485_SetDispDot
*	˵: Сλ
*	    : _addr : ӻ485ַ
*			  _dot : Сλϵȱʡ0ʾС㡣
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_SetDispDot(uint8_t _addr, uint8_t _dot)
{
	MODH_Send06H(_addr, 0x0025, _dot);
}

/*
*********************************************************************************************************
*	  : LED485_SetBright
*	˵: LEDܵ
*	    : _addr : ӻ485ַ
*			  _bright : ֵ 0 - 7
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_SetBright(uint8_t _addr, uint8_t _bright)
{
	MODH_Send06H(_addr, 0x0024, _bright);
}

/*
*********************************************************************************************************
*	  : LED485_ModifyAddr
*	˵: ޸LEDܵĵַ
*	    : _addr : ӻ485ַ
*			  _NewAddr : µַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_ModifyAddr(uint8_t _addr, uint8_t _NewAddr)
{
	MODH_Send06H(_addr, 0x0023, _NewAddr);
}

/*
*********************************************************************************************************
*	  : LED485_DispNumberWithDot
*	˵: ʾС
*	    : _addr : ӻ485ַ
*			  _iNumber : Ҫʾ
*			  _dot : Сλ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_DispNumberWithDot(uint8_t _addr, int16_t _iNumber, uint8_t _dot)
{
/*
	PLC  :0110 00 90 00 02 04 00 0201 EA DB 1C
	?  01:   վţRS485ַ
	?  10 :   룬ʾдĴ
	?  00 90 :   ʾĴ(Сŵ)
	?  00 02:  Ĵ
	?  04:  ݸֽ
	?  00 02  00 ʾţ00=01=ǰʾ-
				02 ʾСλ0ʾС㡣2ʾС2λ
	?  01 EA:   2λֽǰ01 EAʾʮ 490
	?  DB 1C  :   ֽCRC
	ʾ4.90
	 01 10 00 90 00 02 41 E5
*/
	uint16_t buf[2];

	if (_iNumber < 0)			/* ʾ */
	{
		buf[0] = 0x0100 | _dot;
	}
	else
	{
		buf[0] = 0x0000 | _dot;
	}
	if (_iNumber < 0)
	{
		_iNumber = -_iNumber;
	}
	buf[1] = _iNumber;
	
	MODH_Send10H(_addr,0x0090, 2, buf);
}

/*
*********************************************************************************************************
*	  : LED485_DispStr
*	˵: ʾַ
*	    : _addr : ӻ485ַ
*			  _str : Ҫʾַ
*	  ֵ: 
*********************************************************************************************************
*/
void LED485_DispStr(uint8_t _addr, char *_str)
{
/*
	PLC  :
	0110 00 70 00 06 0C 50 32 2E 33 00 00 00 00 00 00 00 00 3B 25
	?  01:   վţRS485ַ
	?  10 :   룬ʾдĴ
	?  0070 :   ʾĴ(ASCII)
	?  00 06:  Ĵ
	?  0C:   ݶεֽ
	?  50 32 2E 33 00 00 00 00 00 00 00 00  :
	ASCII̶ַ12ֽڣȲ12λַұ߱00
	ʾASCIIַP2.3
	?  3B 25  :   ֽCRC
	ʾP2.3
	 01 10 00 70 00 06 41 D0
*/
	uint16_t buf[6];
	uint8_t i;

	for (i = 0; i < 6; i++)
	{
		buf[i] = 0;
	}
	
	for (i = 0; i < 12; i++)
	{
		if (_str[i] == 0)
		{
			break;
		}
		
		if (i % 2)
		{
			buf[i / 2] += _str[i] << 8;
		}
		else
		{
			buf[i / 2] = _str[i];
		}
	}
	
	MODH_Send10H(_addr, 0x0070, 2, buf);
}


/*****************************  www.armfly.com (END OF FILE) *********************************/
