/*
*********************************************************************************************************
*
*	ģ : AD9833 ģ(ͨ16λADC)
*	ļ : bsp_AD9833.c
*	     : V1.0
*	˵     : AD9833ģCPU֮SPIӿڡ֧ӲSPIӿںSPIӿڡSPIߵ 
*			   SCK  MOSI bsp_spi_bus.c, ͨлӲSPISPI
*
*	޸ļ¼ :
*		汾                ˵
*		V1.0   2015-08-09    armfly   װ
*
*	Copyright (C), 2015,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/* SPIߵ SCK MOSI bsp_spi_bus.cã ֧ӲSPISPI */

/* AD9833Ƶ = 25MHz */
#define AD9833_SYSTEM_CLOCK 25000000UL 

/*
	AD9833ģֱӲ嵽STM32-V6CN19ĸ(2*4P 2.54mm)ӿ SPI

	AD9833 ģ    STM32-V5
	  GND   ------  GND
	  VCC   ------  3.3V
      
	  FSYNC ------  PG10/NRF24L01_CSN
	  SCLK  ------  PB3/SPI3_SCK
	  SDATA ------  PB5/SPI3_MOSI 
	  
			------  PB4/SPI3_MISO         --- DAC޶

	  SPISCKʱٶԵ40MHz
*/

/* SPIƬѡ CS,  оƬֲ FSYNC ֡ͬһ˼  */
#define CS_CLK_ENABLE() 	__HAL_RCC_GPIOG_CLK_ENABLE()
#define CS_GPIO				GPIOG
#define CS_PIN				GPIO_PIN_10

#define CS_1()				CS_GPIO->BSRRL = CS_PIN
#define CS_0()				CS_GPIO->BSRRH = CS_PIN


/*岨εļĴֵ*/
#define Triangle_Wave  	0x2002
#define Sine_Wave 		0x2028
#define square wave 	0x2000

static void AD9833_ConfigGPIO(void);
static void AD9833_Write16Bits(uint16_t _cmd);

/*
*********************************************************************************************************
*	  : bsp_InitAD9833
*	˵: STM32GPIOSPIӿڣ AD9833
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitAD9833(void)
{
	AD9833_ConfigGPIO();	/* ƬѡSPI bsp_spi_bus.c н */
	
	/* ʼ */
	{
		/* λƵʺͿƼĴ */
		AD9833_Write16Bits(0x0100);	/* дƼĴλĴ RESET = 0 */
		
		AD9833_WriteFreqReg(0, 0);	/* ƵʼĴ 0 */
		AD9833_WriteFreqReg(1, 0);	/* ƵʼĴ 1 */
		
		AD9833_WritePhaseReg(0, 0);	/* λĴ 0 */
		AD9833_WritePhaseReg(1, 0);	/* λĴ 1 */		
		
		AD9833_Write16Bits(0x0000);	/* дƼĴλĴ RESET = 1 */
	}
	
	AD9833_SelectWave(NONE_WAVE);	/* ֹͣ */
}

/*
*********************************************************************************************************
*	  : AD9833_ConfigGPIO
*	˵: GPIO  SCK  MOSI  MISO SPIߡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void AD9833_ConfigGPIO(void)
{
	/* CS GPIO */
	{
		GPIO_InitTypeDef gpio_init;

		/* GPIOʱ */
		CS_CLK_ENABLE();
		
		gpio_init.Mode = GPIO_MODE_OUTPUT_PP;		/*  */
		gpio_init.Pull = GPIO_NOPULL;				/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_HIGH;  	/* GPIOٶȵȼ */	
		gpio_init.Pin = CS_PIN;	
		HAL_GPIO_Init(CS_GPIO, &gpio_init);	

		CS_1();
	}
}

/*
*********************************************************************************************************
*	  : AD9833_SetCS
*	˵: CS1 SPI
*	    : 
	  ֵ: 
*********************************************************************************************************
*/
void AD9833_SetCS(uint8_t _Level)
{
	if (_Level == 0)
	{
		bsp_SpiBusEnter();	/* ռSPI  */	
		bsp_InitSPIParam(SPI_BAUDRATEPRESCALER_8, SPI_PHASE_1EDGE, SPI_POLARITY_HIGH);		
		CS_0();
	}
	else
	{		
		CS_1();	
		bsp_SpiBusExit();	/* ͷSPI */
	}	
}

/*
*********************************************************************************************************
*	  : AD9833_Write16Bits      
*	˵: SPI߷16bit   Ϳ
*	    : _cmd : 
*	  ֵ: 
*********************************************************************************************************
*/
static void AD9833_Write16Bits(uint16_t _cmd)
{	
	AD9833_SetCS(0);
	
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (_cmd >> 8);
	g_spiTxBuf[g_spiLen++] = (_cmd);
	bsp_spiTransfer();	
	
	AD9833_SetCS(1);
}

/*
*********************************************************************************************************
*	  : AD9833_Write16Bits      
*	˵: ѡ͡NONE_WAVEʾֹͣ
*	    : _type : 
*					NONE_WAVE  ʾֹͣ
*					TRI_WAVE   ʾǲ
*					SINE_WAVE  ʾҲ
*					SQU_WAVE   ʾ
*	  ֵ: 
*********************************************************************************************************
*/
void AD9833_SelectWave(AD9833_WAVE_E _type) 
{	
	/* D5  D1 
		0   0  -- 
	    0   1  -- 
	    1   0  -- 
	*/	
	if (_type == NONE_WAVE)
	{
		AD9833_Write16Bits(0x20C0); /*  */
	}
	else if (_type == TRI_WAVE)
	{
		AD9833_Write16Bits(0x2002); /* ƵʼĴǲ */				
	}
	else if (_type == SINE_WAVE)
	{
		AD9833_Write16Bits(0x2000); /* ƵʼĴҲ */					
	}
	else if (_type == SQU_WAVE)
	{
		AD9833_Write16Bits(0x2028); /* ƵʼĴ */	
	}
}

/*
*********************************************************************************************************
*	  : AD9833_WriteFreqReg      
*	˵: дƵʼĴ  Ҫȷִйһ AD9833_Write16Bits(0x2000); B28=1 ʾдƵʷ2д
*	    : _mode : 0ʾƵʼĴ0 1ʾƵʼĴ1
*			  _freq_reg : ƵʼĴֵ 28bit;
*	  ֵ: 
*********************************************************************************************************
*/
void AD9833_WriteFreqReg(uint8_t _mode, uint32_t _freq_reg)
{
	uint16_t lsb_14bit;
	uint16_t msb_14bit;
	
	lsb_14bit = _freq_reg & 0x3FFF;
	msb_14bit = (_freq_reg >> 14) & 0x3FFF;
	if (_mode == 0)	/* дƵʼĴ0 */
	{
		AD9833_Write16Bits(0x4000 + lsb_14bit);	/* д2Σ1ǵ14λ */		
		AD9833_Write16Bits(0x4000 + msb_14bit);	/* д2Σ2Ǹ14λ */	
	}
	else	/* дƵʼĴ1 */
	{	
		AD9833_Write16Bits(0x8000 + lsb_14bit);	/* д2Σ1ǵ14λ */		
		AD9833_Write16Bits(0x8000 + msb_14bit);	/* д2Σ2Ǹ14λ */	
	}
}

/*
*********************************************************************************************************
*	  : AD9833_WritePhaseReg      
*	˵: дλĴ  
*	    : _mode : 0ʾλĴ0 1ʾλĴ1
*			  _phase_reg : λĴֵ, 12bit
*	  ֵ: 
*********************************************************************************************************
*/
void AD9833_WritePhaseReg(uint8_t _mode, uint32_t _phase_reg)
{
	_phase_reg &= 0xFFF;
	if (_mode == 0)	/* дλĴ0 */
	{
		AD9833_Write16Bits(0xC000 + _phase_reg);
	}
	else	/* дλĴ1 */
	{	
		AD9833_Write16Bits(0xE000 + _phase_reg);
	}
}

/*
*********************************************************************************************************
*	  : AD9833_SetWaveFreq      
*	˵: òƵʡλ0.1Hz
*	    : _WaveFreq Ƶʵλ0.1Hz  100ʾ10.0Hz
*	  ֵ: 
*********************************************************************************************************
*/
void AD9833_SetWaveFreq(uint32_t _WaveFreq)
{
	uint32_t freq_reg;

	/*
		Ƶ _WaveFreq = (25000000 / 2^28) * freq_reg
		Ĵֵ freq_reg =  268435456 / 25000000	* _WaveFreq
	
		268435456 / 25000000 = 10.73741824
	*/	
	//freq = 268435456.0 / AD9833_SYSTEM_CLOCK * _freq;
	freq_reg = ((int64_t)_WaveFreq * 268435456) / (10 * AD9833_SYSTEM_CLOCK);	
	
	AD9833_WriteFreqReg(0, freq_reg);	/* дƵʼĴ */
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
