/*
*********************************************************************************************************
*
*	ģ : DAC8501 ģ(ͨ16λDAC)
*	ļ : bsp_dac8501.c
*	     : V1.0
*	˵     : DAC8501ģCPU֮SPIӿڡ֧ӲSPIӿڡ
*			  ͨл
*
*	޸ļ¼ :
*		汾                ˵
*		V1.0    2015-10-11  armfly  ʽ
*
*	Copyright (C), 2015-2020,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	DAC8501:
	12.7 - 5V;  ʹ3.3V
	4οѹ2.5V (Ƽȱʡģõģ

	SPIʱٶҪ: ߴ30MHz ٶȺܿ.
	SCLK½ضȡ, ÿδ24bitݣ λȴ
*/

#define CS1_CLK_ENABLE() 	__HAL_RCC_GPIOG_CLK_ENABLE()
#define CS1_GPIO			GPIOG
#define CS1_PIN				GPIO_PIN_10

#define CS1_1()				CS1_GPIO->BSRRL = CS1_PIN
#define CS1_0()				CS1_GPIO->BSRRH = CS1_PIN

#define CS2_1()				HC574_SetPin(NRF24L01_CE, 1);
#define CS2_0()				HC574_SetPin(NRF24L01_CE, 0);

/* ѹDACֵĹϵ У׼ xdac y ǵѹ 0.1mV */
#define X1	100
#define Y1  50

#define X2	65000
#define Y2  49400

/*
*********************************************************************************************************
*	  : bsp_InitDAC8501
*	˵: STM32GPIOSPIӿڣ ADS1256
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitDAC8501(void)
{
	/* CS GPIO */
	{
		GPIO_InitTypeDef gpio_init;

		/* GPIOʱ */
		CS1_CLK_ENABLE();
		
		gpio_init.Mode = GPIO_MODE_OUTPUT_PP;		/*  */
		gpio_init.Pull = GPIO_NOPULL;				/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_HIGH;  	/* GPIOٶȵȼ */	
		gpio_init.Pin = CS1_PIN;	
		HAL_GPIO_Init(CS1_GPIO, &gpio_init);	

		/* CS2 ʹչIO.  bsp_fmc_io.c  */
	}

	DAC8501_SetDacData(0, 0);	/* CH10 */
	DAC8501_SetDacData(1, 0);	/* CH20 */
}

/*
*********************************************************************************************************
*	  : DAC8501_SetCS1
*	˵: DAC8501 Ƭѡƺ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void DAC8501_SetCS1(uint8_t _Level)
{
	if (_Level == 0)
	{
		bsp_SpiBusEnter();	/* ռSPI  */	
		bsp_InitSPIParam(SPI_BAUDRATEPRESCALER_8, SPI_PHASE_1EDGE, SPI_POLARITY_LOW);		
		CS1_0();
	}
	else
	{		
		CS1_1();	
		bsp_SpiBusExit();	/* ͷSPI */
	}	
}

/*
*********************************************************************************************************
*	  : DAC8501_SetCS2(0)
*	˵: CS2 SPI
*	    : 
	  ֵ: 
*********************************************************************************************************
*/
void DAC8501_SetCS2(uint8_t _level)
{
	if (_level == 0)
	{
		bsp_SpiBusEnter();	/* ռSPI  */
		bsp_InitSPIParam(SPI_BAUDRATEPRESCALER_8, SPI_PHASE_1EDGE, SPI_POLARITY_LOW);		
		CS2_1();
	}
	else
	{
		CS2_1();
		bsp_SpiBusExit();	/* ͷSPI */
	}
}

/*
*********************************************************************************************************
*	  : DAC8501_SetDacData
*	˵: DAC
*	    : _ch, ͨ,
*		     _data : 
*	  ֵ: 
*********************************************************************************************************
*/
void DAC8501_SetDacData(uint8_t _ch, uint16_t _dac)
{
	uint32_t data;

	/*
		DAC8501.pdf page 12 24bit

		DB24:18 = xxxxx 
		DB17 PD1
		DB16 PD0

		DB150  16λ

		 PD1 PD0 4ֹģʽ
		      0   0  ---> ģʽ
		      0   1  ---> 1KŷGND
		      1   0  ---> 100KŷGND
		      1   1  ---> 
	*/

	data = _dac; /* PD1 PD0 = 00 ģʽ */

	if (_ch == 0)
	{
		DAC8501_SetCS1(0);
	}
	else
	{
		DAC8501_SetCS2(0);
	}

	/*DAC8501 SCLKʱӸߴ30M˿Բӳ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (data >> 16);
	g_spiTxBuf[g_spiLen++] = (data >> 8);
	g_spiTxBuf[g_spiLen++] = (data);
	bsp_spiTransfer();	

	if (_ch == 0)
	{
		DAC8501_SetCS1(1);
	}
	else
	{
		DAC8501_SetCS2(1);
	}
}

/*
*********************************************************************************************************
*	  : DAC8501_DacToVoltage
*	˵: DACֵΪѹֵλ0.1mV
*	    : _dac  16λDAC
*	  ֵ: ѹλ0.1mV
*********************************************************************************************************
*/
int32_t DAC8501_DacToVoltage(uint16_t _dac)
{
	int32_t y;

	/* CaculTwoPoint(int32_t x1, int32_t y1, int32_t x2, int32_t y2, int32_t x);*/
	y =  CaculTwoPoint(X1, Y1, X2, Y2, _dac);
	if (y < 0)
	{
		y = 0;
	}
	return y;
}

/*
*********************************************************************************************************
*	  : DAC8501_DacToVoltage
*	˵: DACֵΪѹֵλ 0.1mV
*	    : _volt ѹλ0.1mV
*	  ֵ: 16λDAC
*********************************************************************************************************
*/
uint32_t DAC8501_VoltageToDac(int32_t _volt)
{
	/* CaculTwoPoint(int32_t x1, int32_t y1, int32_t x2, int32_t y2, int32_t x);*/
	return CaculTwoPoint(Y1, X1, Y2, X2, _volt);
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
