/*
*********************************************************************************************************
*
*	ģ : SPIӿڴFLASH дģ
*	ļ : bsp_spi_flash.c
*	     : V1.0
*	˵     : ֧ SST25VF016BMX25L1606E  W25Q64BVSSIG
*			   SST25VF016B дAAIָдЧʡ
*
*			   ȱʡʹSTM32F4ӲSPI1ӿڣʱƵΪ 42MHz Ƶʹã
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-02-01 armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/* FlshƬѡGPIO˿ڣ PD13  */
#define SF_CS_CLK_ENABLE() 			__HAL_RCC_GPIOD_CLK_ENABLE()
#define SF_CS_GPIO					GPIOD
#define SF_CS_PIN					GPIO_PIN_13
#define SF_CS_0()					SF_CS_GPIO->BSRRH = SF_CS_PIN
#define SF_CS_1()					SF_CS_GPIO->BSRRL = SF_CS_PIN
	
#define CMD_AAI       0xAD  	/* AAI ָ(FOR SST25VF016B) */
#define CMD_DISWR	  0x04		/* ֹд, ˳AAI״̬ */
#define CMD_EWRSR	  0x50		/* д״̬Ĵ */
#define CMD_WRSR      0x01  	/* д״̬Ĵ */
#define CMD_WREN      0x06		/* дʹ */
#define CMD_READ      0x03  	/*  */
#define CMD_RDSR      0x05		/* ״̬Ĵ */
#define CMD_RDID      0x9F		/* ID */
#define CMD_SE        0x20		/*  */
#define CMD_BE        0xC7		/*  */
#define DUMMY_BYTE    0xA5		/* Ϊֵڶ */

#define WIP_FLAG      0x01		/* ״̬Ĵеڱ̱־WIP) */

SFLASH_T g_tSF;

#if 0
static void sf_WriteStatus(uint8_t _ucValue);
#endif

static void sf_WriteEnable(void);
static void sf_WaitForWriteEnd(void);
static uint8_t sf_NeedErase(uint8_t * _ucpOldBuf, uint8_t *_ucpNewBuf, uint16_t _uiLen);
static uint8_t sf_CmpData(uint32_t _uiSrcAddr, uint8_t *_ucpTar, uint32_t _uiSize);
static uint8_t sf_AutoWritePage(uint8_t *_ucpSrc, uint32_t _uiWrAddr, uint16_t _usWrLen);

static uint8_t s_spiBuf[4*1024];	/* дȶpage޸Ļpageд */

/*
*********************************************************************************************************
*	  : bsp_InitSFlash
*	˵: falshӲʼ CS GPIO ȡID
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitSFlash(void)
{
	/* CS GPIO */
	{
		GPIO_InitTypeDef gpio_init;

		/* GPIOʱ */
		SF_CS_CLK_ENABLE();
		
		gpio_init.Mode = GPIO_MODE_OUTPUT_PP;		/*  */
		gpio_init.Pull = GPIO_NOPULL;				/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_HIGH;  	/* GPIOٶȵȼ */	
		gpio_init.Pin = SF_CS_PIN;	
		HAL_GPIO_Init(SF_CS_GPIO, &gpio_init);	
	}
	
	/* ȡоƬID, ԶʶоƬͺ */
	sf_ReadInfo();
}	

/*
*********************************************************************************************************
*	  : sf_SetCS
*	˵: FALSHƬѡƺ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void sf_SetCS(uint8_t _Level)
{
	if (_Level == 0)
	{
		bsp_SpiBusEnter();	
		bsp_InitSPIParam(SPI_BAUDRATEPRESCALER_8, SPI_PHASE_1EDGE, SPI_POLARITY_LOW);		
		SF_CS_0();
	}
	else
	{		
		SF_CS_1();	
		bsp_SpiBusExit();		
	}
}

/*
*********************************************************************************************************
*	  : sf_EraseSector
*	˵: ָ
*	    :  _uiSectorAddr : ַ
*	  ֵ: 
*********************************************************************************************************
*/
void sf_EraseSector(uint32_t _uiSectorAddr)
{
	sf_WriteEnable();								/* дʹ */

	/*  */
	sf_SetCS(0);									/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = CMD_SE;						/* Ͳ */
	g_spiTxBuf[g_spiLen++] = ((_uiSectorAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	g_spiTxBuf[g_spiLen++] = ((_uiSectorAddr & 0xFF00) >> 8);		/* ַм8bit */
	g_spiTxBuf[g_spiLen++] = (_uiSectorAddr & 0xFF);				/* ַ8bit */	
	bsp_spiTransfer();
	sf_SetCS(1);									/* Ƭѡ */

	sf_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : sf_EraseChip
*	˵: оƬ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void sf_EraseChip(void)
{	
	sf_WriteEnable();								/* дʹ */

	/*  */
	sf_SetCS(0);		/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = CMD_BE;				/* Ƭ */
	bsp_spiTransfer();
	sf_SetCS(1);									/* Ƭѡ */

	sf_WaitForWriteEnd();							/* ȴFlashڲд */
}

/*
*********************************************************************************************************
*	  : sf_PageWrite
*	˵: һpageдֽڡֽڸܳҳС4K)
*	    :  	_pBuf : Դ
*				_uiWriteAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 
*********************************************************************************************************
*/
void sf_PageWrite(uint8_t * _pBuf, uint32_t _uiWriteAddr, uint16_t _usSize)
{
	uint32_t i, j;

	if (g_tSF.ChipID == SST25VF016B_ID)
	{
		/* AAIָҪݸż */
		if ((_usSize < 2) && (_usSize % 2))
		{
			return ;
		}

		sf_WriteEnable();								/* дʹ */

		sf_SetCS(0);									/* ʹƬѡ */
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = CMD_AAI;								/* AAI(ַԶӱ) */
		g_spiTxBuf[g_spiLen++] = ((_uiWriteAddr & 0xFF0000) >> 16);		/* ַĸ8bit */
		g_spiTxBuf[g_spiLen++] = ((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
		g_spiTxBuf[g_spiLen++] = (_uiWriteAddr & 0xFF);					/* ַ8bit */		
		g_spiTxBuf[g_spiLen++] = (*_pBuf++);							/* ͵1 */
		g_spiTxBuf[g_spiLen++] = (*_pBuf++);							/* ͵2 */
		bsp_spiTransfer();
		sf_SetCS(1);									/* Ƭѡ */

		sf_WaitForWriteEnd();							/* ȴFlashڲд */

		_usSize -= 2;									/* ʣֽ */

		for (i = 0; i < _usSize / 2; i++)
		{
			sf_SetCS(0);	/* ʹƬѡ */	
			g_spiLen = 0;
			g_spiTxBuf[g_spiLen++] = (CMD_AAI);						/* AAI(ַԶӱ) */
			g_spiTxBuf[g_spiLen++] = (*_pBuf++);					/*  */
			g_spiTxBuf[g_spiLen++] = (*_pBuf++);					/*  */
			bsp_spiTransfer();
			sf_SetCS(1);								/* Ƭѡ */
			sf_WaitForWriteEnd();						/* ȴFlashڲд */
		}

		/* д״̬ */
		sf_SetCS(0);
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = (CMD_DISWR);
		bsp_spiTransfer();
		sf_SetCS(1);

		sf_WaitForWriteEnd();							/* ȴFlashڲд */
	}
	else	/* for MX25L1606E  W25Q64BV */
	{
		for (j = 0; j < _usSize / 256; j++)
		{
			sf_WriteEnable();								/* дʹ */

			sf_SetCS(0);									/* ʹƬѡ */
			g_spiLen = 0;
			g_spiTxBuf[g_spiLen++] = (0x02);								/* AAI(ַԶӱ) */
			g_spiTxBuf[g_spiLen++] = ((_uiWriteAddr & 0xFF0000) >> 16);		/* ַĸ8bit */
			g_spiTxBuf[g_spiLen++] = ((_uiWriteAddr & 0xFF00) >> 8);		/* ַм8bit */
			g_spiTxBuf[g_spiLen++] = (_uiWriteAddr & 0xFF);					/* ַ8bit */
			for (i = 0; i < 256; i++)
			{
				g_spiTxBuf[g_spiLen++] = (*_pBuf++);		/*  */
			}
			bsp_spiTransfer();
			sf_SetCS(1);								/* ֹƬѡ */

			sf_WaitForWriteEnd();						/* ȴFlashڲд */

			_uiWriteAddr += 256;
		}

		/* д״̬ */
		sf_SetCS(0);
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = (CMD_DISWR);
		bsp_spiTransfer();
		sf_SetCS(1);

		sf_WaitForWriteEnd();							/* ȴFlashڲд */
	}
}

/*
*********************************************************************************************************
*	  : sf_ReadBuffer
*	˵: ȡֽڡֽڸܳоƬ
*	    :  	_pBuf : Դ
*				_uiReadAddr ׵ַ
*				_usSize ݸ, ԴPAGE_SIZE,ǲܳоƬ
*	  ֵ: 
*********************************************************************************************************
*/
void sf_ReadBuffer(uint8_t * _pBuf, uint32_t _uiReadAddr, uint32_t _uiSize)
{
	uint16_t rem;
	uint16_t i;
	
	/* ȡݳΪ0߳Flashַռ䣬ֱӷ */
	if ((_uiSize == 0) ||(_uiReadAddr + _uiSize) > g_tSF.TotalSize)
	{
		return;
	}

	/*  */
	sf_SetCS(0);									/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (CMD_READ);							/* Ͷ */
	g_spiTxBuf[g_spiLen++] = ((_uiReadAddr & 0xFF0000) >> 16);	/* ַĸ8bit */
	g_spiTxBuf[g_spiLen++] = ((_uiReadAddr & 0xFF00) >> 8);		/* ַм8bit */
	g_spiTxBuf[g_spiLen++] = (_uiReadAddr & 0xFF);				/* ַ8bit */
	bsp_spiTransfer();
	
	/* ʼݣʵײDMAޣְ */
	for (i = 0; i < _uiSize / SPI_BUFFER_SIZE; i++)
	{
		g_spiLen = SPI_BUFFER_SIZE;
		bsp_spiTransfer();
		
		memcpy(_pBuf, g_spiRxBuf, SPI_BUFFER_SIZE);
		_pBuf += SPI_BUFFER_SIZE;
	}
	
	rem = _uiSize % SPI_BUFFER_SIZE;	/* ʣֽ */
	if (rem > 0)
	{
		g_spiLen = rem;
		bsp_spiTransfer();
		
		memcpy(_pBuf, g_spiRxBuf, rem);
	}
	
	sf_SetCS(1);									/* Ƭѡ */
}

/*
*********************************************************************************************************
*	  : sf_CmpData
*	˵: ȽFlash.
*	    :  	_ucpTar : ݻ
*				_uiSrcAddr Flashַ
*				_uiSize ݸ, ԴPAGE_SIZE,ǲܳоƬ
*	  ֵ: 0 = , 1 = 
*********************************************************************************************************
*/
static uint8_t sf_CmpData(uint32_t _uiSrcAddr, uint8_t *_ucpTar, uint32_t _uiSize)
{
	uint16_t i, j;
	uint16_t rem;

	/* ȡݳΪ0߳Flashַռ䣬ֱӷ */
	if ((_uiSrcAddr + _uiSize) > g_tSF.TotalSize)
	{
		return 1;
	}

	if (_uiSize == 0)
	{
		return 0;
	}

	sf_SetCS(0);									/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (CMD_READ);							/* Ͷ */
	g_spiTxBuf[g_spiLen++] = ((_uiSrcAddr & 0xFF0000) >> 16);		/* ַĸ8bit */
	g_spiTxBuf[g_spiLen++] = ((_uiSrcAddr & 0xFF00) >> 8);			/* ַм8bit */
	g_spiTxBuf[g_spiLen++] = (_uiSrcAddr & 0xFF);					/* ַ8bit */
	bsp_spiTransfer();
	
	/* ʼݣΪײDMAޣְ */
	for (i = 0; i < _uiSize / SPI_BUFFER_SIZE; i++)
	{
		g_spiLen = SPI_BUFFER_SIZE;
		bsp_spiTransfer();
		
		for (j = 0; j < SPI_BUFFER_SIZE; j++)
		{
			if (g_spiRxBuf[j] != *_ucpTar++)
			{
				goto NOTEQ;		/*  */
			}
		}
	}
	
	rem = _uiSize % SPI_BUFFER_SIZE;	/* ʣֽ */
	if (rem > 0)
	{
		g_spiLen = rem;
		bsp_spiTransfer();
		
		for (j = 0; j < rem; j++)
		{
			if (g_spiRxBuf[j] != *_ucpTar++)
			{
				goto NOTEQ;		/*  */
			}
		}
	}
	sf_SetCS(1);
	return 0;		/*  */
	
NOTEQ:	
	sf_SetCS(1);	/*  */
	return 1;
}

/*
*********************************************************************************************************
*	  : sf_NeedErase
*	˵: ждPAGEǰǷҪȲ
*	    :   _ucpOldBuf  
*			   _ucpNewBuf  
*			   _uiLen ݸܳҳС
*	  ֵ: 0 : Ҫ 1 Ҫ
*********************************************************************************************************
*/
static uint8_t sf_NeedErase(uint8_t * _ucpOldBuf, uint8_t *_ucpNewBuf, uint16_t _usLen)
{
	uint16_t i;
	uint8_t ucOld;

	/*
	㷨1old , new 
	      old    new
		  1101   0101
	~     1111
		= 0010   0101

	㷨2: old 󷴵Ľ new λ
		  0010   old
	&	  0101   new
		 =0000

	㷨3: Ϊ0,ʾ. ʾҪ
	*/

	for (i = 0; i < _usLen; i++)
	{
		ucOld = *_ucpOldBuf++;
		ucOld = ~ucOld;

		/* עд: if (ucOld & (*_ucpNewBuf++) != 0) */
		if ((ucOld & (*_ucpNewBuf++)) != 0)
		{
			return 1;
		}
	}
	return 0;
}

/*
*********************************************************************************************************
*	  : sf_AutoWritePage
*	˵: д1PAGEУ,ȷдΡԶɲ
*	    :  	_pBuf : Դ
*				_uiWriteAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 0 :  1  ɹ
*********************************************************************************************************
*/
static uint8_t sf_AutoWritePage(uint8_t *_ucpSrc, uint32_t _uiWrAddr, uint16_t _usWrLen)
{
	uint16_t i;
	uint16_t j;					/* ʱ */
	uint32_t uiFirstAddr;		/* ַ */
	uint8_t ucNeedErase;		/* 1ʾҪ */
	uint8_t cRet;

	/* Ϊ0ʱ,ֱΪɹ */
	if (_usWrLen == 0)
	{
		return 1;
	}

	/* ƫƵַоƬ˳ */
	if (_uiWrAddr >= g_tSF.TotalSize)
	{
		return 0;
	}

	/* ݳȴ˳ */
	if (_usWrLen > g_tSF.PageSize)
	{
		return 0;
	}

	/* FLASHеûб仯,дFLASH */
	sf_ReadBuffer(s_spiBuf, _uiWrAddr, _usWrLen);
	if (memcmp(s_spiBuf, _ucpSrc, _usWrLen) == 0)
	{
		return 1;
	}

	/* жǷҪȲ */
	/* ޸Ϊݣλ 1->0  0->0, ,Flash */
	ucNeedErase = 0;
	if (sf_NeedErase(s_spiBuf, _ucpSrc, _usWrLen))
	{
		ucNeedErase = 1;
	}

	uiFirstAddr = _uiWrAddr & (~(g_tSF.PageSize - 1));

	if (_usWrLen == g_tSF.PageSize)		/* д */
	{
		for	(i = 0; i < g_tSF.PageSize; i++)
		{
			s_spiBuf[i] = _ucpSrc[i];
		}
	}
	else						/* д */
	{
		/* Ƚݶ */
		sf_ReadBuffer(s_spiBuf, uiFirstAddr, g_tSF.PageSize);

		/* ݸ */
		i = _uiWrAddr & (g_tSF.PageSize - 1);
		memcpy(&s_spiBuf[i], _ucpSrc, _usWrLen);
	}

	/* д֮У飬ȷд3 */
	cRet = 0;
	for (i = 0; i < 3; i++)
	{

		/* ޸Ϊݣλ 1->0  0->0, ,Flash */
		if (ucNeedErase == 1)
		{
			sf_EraseSector(uiFirstAddr);		/* 1 */
		}

		/* һPAGE */
		sf_PageWrite(s_spiBuf, uiFirstAddr, g_tSF.PageSize);

		if (sf_CmpData(_uiWrAddr, _ucpSrc, _usWrLen) == 0)
		{
			cRet = 1;
			break;
		}
		else
		{
			if (sf_CmpData(_uiWrAddr, _ucpSrc, _usWrLen) == 0)
			{
				cRet = 1;
				break;
			}

			/* ʧܺӳһʱ */
			for (j = 0; j < 10000; j++);
		}
	}

	return cRet;
}

/*
*********************************************************************************************************
*	  : sf_WriteBuffer
*	˵: д1У,ȷдΡԶɲ
*	    :  	_pBuf : Դ
*				_uiWrAddr Ŀ׵ַ
*				_usSize ݸܳҳС
*	  ֵ: 1 : ɹ 0  ʧ
*********************************************************************************************************
*/
uint8_t sf_WriteBuffer(uint8_t* _pBuf, uint32_t _uiWriteAddr, uint16_t _usWriteSize)
{
	uint16_t NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0, temp = 0;

	Addr = _uiWriteAddr % g_tSF.PageSize;
	count = g_tSF.PageSize - Addr;
	NumOfPage =  _usWriteSize / g_tSF.PageSize;
	NumOfSingle = _usWriteSize % g_tSF.PageSize;

	if (Addr == 0) /* ʼַҳ׵ַ  */
	{
		if (NumOfPage == 0) /* ݳСҳС */
		{
			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, _usWriteSize) == 0)
			{
				return 0;
			}
		}
		else 	/* ݳȴڵҳС */
		{
			while (NumOfPage--)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, g_tSF.PageSize) == 0)
				{
					return 0;
				}
				_uiWriteAddr +=  g_tSF.PageSize;
				_pBuf += g_tSF.PageSize;
			}
			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, NumOfSingle) == 0)
			{
				return 0;
			}
		}
	}
	else  /* ʼַҳ׵ַ  */
	{
		if (NumOfPage == 0) /* ݳСҳС */
		{
			if (NumOfSingle > count) /* (_usWriteSize + _uiWriteAddr) > SPI_FLASH_PAGESIZE */
			{
				temp = NumOfSingle - count;

				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, count) == 0)
				{
					return 0;
				}

				_uiWriteAddr +=  count;
				_pBuf += count;

				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, temp) == 0)
				{
					return 0;
				}
			}
			else
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, _usWriteSize) == 0)
				{
					return 0;
				}
			}
		}
		else	/* ݳȴڵҳС */
		{
			_usWriteSize -= count;
			NumOfPage =  _usWriteSize / g_tSF.PageSize;
			NumOfSingle = _usWriteSize % g_tSF.PageSize;

			if (sf_AutoWritePage(_pBuf, _uiWriteAddr, count) == 0)
			{
				return 0;
			}

			_uiWriteAddr +=  count;
			_pBuf += count;

			while (NumOfPage--)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, g_tSF.PageSize) == 0)
				{
					return 0;
				}
				_uiWriteAddr +=  g_tSF.PageSize;
				_pBuf += g_tSF.PageSize;
			}

			if (NumOfSingle != 0)
			{
				if (sf_AutoWritePage(_pBuf, _uiWriteAddr, NumOfSingle) == 0)
				{
					return 0;
				}
			}
		}
	}
	return 1;	/* ɹ */
}

/*
*********************************************************************************************************
*	  : sf_ReadID
*	˵: ȡID
*	    :  
*	  ֵ: 32bitID (8bit0ЧIDλΪ24bit
*********************************************************************************************************
*/
uint32_t sf_ReadID(void)
{
	uint32_t uiID;
	uint8_t id1, id2, id3;

	sf_SetCS(0);									/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[0] = (CMD_RDID);								/* ͶID */
	g_spiLen = 4;
	bsp_spiTransfer();
	
	id1 = g_spiRxBuf[1];					/* IDĵ1ֽ */
	id2 = g_spiRxBuf[2];					/* IDĵ2ֽ */
	id3 = g_spiRxBuf[3];					/* IDĵ3ֽ */
	sf_SetCS(1);									/* Ƭѡ */

	uiID = ((uint32_t)id1 << 16) | ((uint32_t)id2 << 8) | id3;

	return uiID;
}

/*
*********************************************************************************************************
*	  : sf_ReadInfo
*	˵: ȡID,
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void sf_ReadInfo(void)
{
	/* ԶʶFlashͺ */
	{
		g_tSF.ChipID = sf_ReadID();	/* оƬID */

		switch (g_tSF.ChipID)
		{
			case SST25VF016B_ID:
				strcpy(g_tSF.ChipName, "SST25VF016B");
				g_tSF.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case MX25L1606E_ID:
				strcpy(g_tSF.ChipName, "MX25L1606E");
				g_tSF.TotalSize = 2 * 1024 * 1024;	/*  = 2M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;

			case W25Q64BV_ID:
				strcpy(g_tSF.ChipName, "W25Q64");
				g_tSF.TotalSize = 8 * 1024 * 1024;	/*  = 8M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;
			
			case W25Q128_ID:
				strcpy(g_tSF.ChipName, "W25Q128");
				g_tSF.TotalSize = 16 * 1024 * 1024;	/*  = 8M */
				g_tSF.PageSize = 4 * 1024;			/* ҳС = 4K */
				break;			

			default:
				strcpy(g_tSF.ChipName, "Unknow Flash");
				g_tSF.TotalSize = 2 * 1024 * 1024;
				g_tSF.PageSize = 4 * 1024;
				break;
		}
	}
}

/*
*********************************************************************************************************
*	  : sf_WriteEnable
*	˵: дʹ
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WriteEnable(void)
{
	sf_SetCS(0);									/* ʹƬѡ */
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (CMD_WREN);								/*  */
	bsp_spiTransfer();
	sf_SetCS(1);									/* Ƭѡ */
}

#if 0
/*
*********************************************************************************************************
*	  : sf_WriteStatus
*	˵: д״̬Ĵ
*	    :  _ucValue : ״̬Ĵֵ
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WriteStatus(uint8_t _ucValue)
{
	if (g_tSF.ChipID == SST25VF016B_ID)
	{
		/* 1ʹд״̬Ĵ */
		sf_SetCS(0);									/* ʹƬѡ */
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = (CMD_EWRSR);							/*  д״̬Ĵ */
		bsp_spiTransfer();
		sf_SetCS(1);									/* Ƭѡ */

		/* 2д״̬Ĵ */
		sf_SetCS(0);									/* ʹƬѡ */
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = (CMD_WRSR);							/*  д״̬Ĵ */
		g_spiTxBuf[g_spiLen++] = (_ucValue);							/* ݣ״̬Ĵֵ */
		bsp_spiTransfer();
		sf_SetCS(1);									/* Ƭѡ */
	}
	else
	{
		sf_SetCS(0);									/* ʹƬѡ */
		g_spiLen = 0;
		g_spiTxBuf[g_spiLen++] = (CMD_WRSR);							/*  д״̬Ĵ */
		g_spiTxBuf[g_spiLen++] = (_ucValue);							/* ݣ״̬Ĵֵ */
		bsp_spiTransfer();
		sf_SetCS(1);									/* Ƭѡ */
	}
}
#endif

/*
*********************************************************************************************************
*	  : sf_WaitForWriteEnd
*	˵: ѭѯķʽȴڲд
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
static void sf_WaitForWriteEnd(void)
{
	sf_SetCS(0);									/* ʹƬѡ */
	g_spiTxBuf[0] = (CMD_RDSR);							/*  ״̬Ĵ */
	g_spiLen = 2;
	bsp_spiTransfer();	
	sf_SetCS(1);									/* Ƭѡ */
	
	while(1)
	{
		sf_SetCS(0);									/* ʹƬѡ */
		g_spiTxBuf[0] = (CMD_RDSR);						/*  ״̬Ĵ */
		g_spiTxBuf[1] = 0;		/* ޹ */
		g_spiLen = 2;
		bsp_spiTransfer();	
		sf_SetCS(1);									/* Ƭѡ */
		
		if ((g_spiRxBuf[1] & WIP_FLAG) != SET)	/* ж״̬Ĵæ־λ */
		{
			break;
		}		
	}	
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
