/*
*********************************************************************************************************
*
*	ģ : TM7705 ģ(2ͨPGA16λADC)
*	ļ : bsp_tm7705.c
*	     : V1.0
*	˵     : TM7705ģCPU֮SPIӿڡ֧ӲSPIӿںSPIӿڡ
*			  ͨл
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2013-10-20  armfly  ʽ
*
*	Copyright (C), 2013-2014,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

//#define tm_printf	printf
#define tm_printf(...)

/* ͨ1ͨ2,뻺壬 */
#define __CH1_GAIN_BIPOLAR_BUF	(GAIN_1 | UNIPOLAR | BUF_EN)
#define __CH2_GAIN_BIPOLAR_BUF	(GAIN_1 | UNIPOLAR | BUF_EN)

/*
	TM7705ģֱӲ嵽STM32-V6nRF24L01ģĸӿϡ
	  
    TM7705ģ   STM32-V7
      SCK   ------  PB3/SPI3_SCK
      DOUT  ------  PB4/SPI3_MISO
      DIN   ------  PB5/SPI3_MOSI
	  
      CS    ------  PG10/NRF24L01_CSN
      DRDY  ------  PE4/NRF24L01_IRQ
      RST   ------  չIO/NRF24L01_CE (λ RESET)

*/

/* SPIߵSCKMOSIMISO  bsp_spi_bus.c  */

/* CSƬѡ */	
#define CS_CLK_ENABLE() 	__HAL_RCC_GPIOG_CLK_ENABLE()
#define CS_GPIO				GPIOG
#define CS_PIN				GPIO_PIN_10
#define CS_1()				CS_GPIO->BSRRL = CS_PIN
#define CS_0()				CS_GPIO->BSRRH = CS_PIN

/* DRDY */	
#define DRDY_CLK_ENABLE() 	__HAL_RCC_GPIOE_CLK_ENABLE()
#define DRDY_GPIO			GPIOE
#define DRDY_PIN			GPIO_PIN_4
#define DRDY_IS_LOW()		((DRDY_GPIO->IDR & DRDY_PIN) == 0)

/* RESET ʹչIO */	
#define RESET_1()			HC574_SetPin(NRF24L01_CE, 1);
#define RESET_0()			HC574_SetPin(NRF24L01_CE, 0);

/* ͨżĴbit */
enum
{
	/* Ĵѡ  RS2 RS1 RS0  */
	REG_COMM	= 0x00,	/* ͨżĴ */
	REG_SETUP	= 0x10,	/* üĴ */
	REG_CLOCK	= 0x20,	/* ʱӼĴ */
	REG_DATA	= 0x30,	/* ݼĴ */
	REG_ZERO_CH1	= 0x60,	/* CH1 ƫƼĴ */
	REG_FULL_CH1	= 0x70,	/* CH1 ̼Ĵ */
	REG_ZERO_CH2	= 0x61,	/* CH2 ƫƼĴ */
	REG_FULL_CH2	= 0x71,	/* CH2 ̼Ĵ */

	/* д */
	WRITE 		= 0x00,	/* д */
	READ 		= 0x08,	/*  */

	/* ͨ */
	CH_1		= 0,	/* AIN1+  AIN1- */
	CH_2		= 1,	/* AIN2+  AIN2- */
	CH_3		= 2,	/* AIN1-  AIN1- */
	CH_4		= 3		/* AIN1-  AIN2- */
};

/* üĴbit */
enum
{
	MD_NORMAL		= (0 << 6),	/* ģʽ */
	MD_CAL_SELF		= (1 << 6),	/* У׼ģʽ */
	MD_CAL_ZERO		= (2 << 6),	/* У׼0̶ģʽ */
	MD_CAL_FULL		= (3 << 6),	/* У׼̶ģʽ */

	GAIN_1			= (0 << 3),	/*  */
	GAIN_2			= (1 << 3),	/*  */
	GAIN_4			= (2 << 3),	/*  */
	GAIN_8			= (3 << 3),	/*  */
	GAIN_16			= (4 << 3),	/*  */
	GAIN_32			= (5 << 3),	/*  */
	GAIN_64			= (6 << 3),	/*  */
	GAIN_128		= (7 << 3),	/*  */

	/* ˫ԻǵԶıκźŵ״ֻ̬ıݵĴתϵУ׼ */
	BIPOLAR			= (0 << 2),	/* ˫ */
	UNIPOLAR		= (1 << 2),	/*  */

	BUF_NO			= (0 << 1),	/* ޻壨ڲ) */
	BUF_EN			= (1 << 1),	/* л (ڲ) */

	FSYNC_0			= 0,
	FSYNC_1			= 1		/*  */
};

/* ʱӼĴbit */
enum
{
	CLKDIS_0	= 0x00,		/* ʱʹ Ӿʱʹܲ񵴣 */
	CLKDIS_1	= 0x10,		/* ʱӽֹ ⲿṩʱʱøλԽֹMCK_OUTʱʡ */

	/*
		2.4576MHzCLKDIV=0 Ϊ 4.9152MHz CLKDIV=1 CLK Ӧ 0
		1MHz CLKDIV=0  2MHz   CLKDIV=1 CLK λӦ  1
	*/
	CLK_4_9152M = 0x08,
	CLK_2_4576M = 0x00,
	CLK_1M 		= 0x04,
	CLK_2M 		= 0x0C,

	FS_50HZ		= 0x00,
	FS_60HZ		= 0x01,
	FS_250HZ	= 0x02,
	FS_500HZ	= 0x04,

	/*
		ʮšӳӦTM7705 ȵķ
			ʹʱΪ 2.4576MHz ʱǿҽ齫ʱӼĴΪ 84H,ʱΪ10Hz,ÿ0.1S һݡ
			ʹʱΪ 1MHz ʱǿҽ齫ʱӼĴΪ80H, ʱΪ4Hz, ÿ0.25S һ
	*/
	ZERO_0		= 0x00,
	ZERO_1		= 0x80
};

static void TM7705_SyncSPI(void);
static void TM7705_WriteByte(uint8_t _data);
static void TM7705_Write3Byte(uint32_t _data);

static void TM7705_WaitDRDY(void);
static void TM7705_ResetHard(void);

void TM7705_CfgSpiHard(void);

uint8_t g_TM7705_OK = 0;	/* ȫֱ־ʾTM7705оƬǷ  */

uint16_t g_TM7705_Adc1;
uint16_t g_TM7705_Adc2;

/*
*********************************************************************************************************
*	  : uint8_t
*	˵: STM32GPIOSPIӿڣ TM7705
*	    : 
*	  ֵ: 0 ʾʧ; 1 ʾɹ
*********************************************************************************************************
*/
void bsp_InitTM7705(void)
{
	/* GPIO */
	{
		GPIO_InitTypeDef gpio_init;

		/* GPIOʱ */
		CS_CLK_ENABLE();
		DRDY_CLK_ENABLE();
		
		gpio_init.Mode = GPIO_MODE_OUTPUT_PP;		/*  */
		gpio_init.Pull = GPIO_NOPULL;				/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_HIGH;  	/* GPIOٶȵȼ */			
		gpio_init.Pin = CS_PIN;	
		HAL_GPIO_Init(CS_GPIO, &gpio_init);	

		/* DRDY Ϊ */
		gpio_init.Mode = GPIO_MODE_INPUT;			/*  */
		gpio_init.Pull = GPIO_NOPULL;				/* 費ʹ */
		gpio_init.Speed = GPIO_SPEED_FREQ_HIGH;  	/* GPIOٶȵȼ */
		gpio_init.Pin = DRDY_PIN;	
		HAL_GPIO_Init(DRDY_GPIO, &gpio_init);			
	}

	bsp_DelayMS(10);

	TM7705_ResetHard();		/* Ӳλ */

	/*
		ڽӿжʧ£DIN ߵƽд㹻ʱ䣨 32ʱڣ
		TM7705 صĬ״̬
	*/
	bsp_DelayMS(5);

	TM7705_SyncSPI();		/* ͬSPIӿʱ */

	bsp_DelayMS(5);

	/* λ֮, ʱӼĴӦ 0x05 */
	{
		if (TM7705_ReadReg(REG_CLOCK) == 0x05)
		{
			g_TM7705_OK = 1;
		}
		else
		{
			g_TM7705_OK = 0;
		}
	}

	/* ʱӼĴ */
	TM7705_WriteByte(REG_CLOCK | WRITE | CH_1);			/* дͨżĴһдʱӼĴ */

	TM7705_WriteByte(CLKDIS_0 | CLK_4_9152M | FS_50HZ);	/* ˢ50Hz */
	//TM7705_WriteByte(CLKDIS_0 | CLK_4_9152M | FS_500HZ);	/* ˢ500Hz */

	/* ÿϵһУ׼ */
	TM7705_CalibSelf(1);	/* ڲУ׼ CH1 */
	bsp_DelayMS(5);
}

/*
*********************************************************************************************************
*	  : TM7705_SetCS
*	˵: TM7705 Ƭѡƺ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_SetCS(uint8_t _Level)
{
	if (_Level == 0)
	{
		bsp_SpiBusEnter();	/* ռSPI  */	
		bsp_InitSPIParam(SPI_BAUDRATEPRESCALER_8, SPI_PHASE_2EDGE, SPI_POLARITY_HIGH);		
		CS_0();
	}
	else
	{		
		CS_1();	
		bsp_SpiBusExit();	/* ͷSPI */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_ResetHard
*	˵: Ӳλ TM7705оƬ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_ResetHard(void)
{
	RESET_1();
	bsp_DelayMS(1);
	RESET_0();
	bsp_DelayMS(2);
	RESET_1();
	bsp_DelayMS(1);
}

/*
*********************************************************************************************************
*	  : TM7705_SyncSPI
*	˵: ͬTM7705оƬSPIӿʱ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_SyncSPI(void)
{
	/* AD7705нӿʧ临λλҪʱ500usٷ */
	TM7705_SetCS(0);
	
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (0xFF);
	g_spiTxBuf[g_spiLen++] = (0xFF);
	g_spiTxBuf[g_spiLen++] = (0xFF);
	g_spiTxBuf[g_spiLen++] = (0xFF);
	bsp_spiTransfer();
	
	TM7705_SetCS(1);
}

/*
*********************************************************************************************************
*	  : TM7705_WriteByte
*	˵: д1ֽڡCS
*	    : _data Ҫд
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_WriteByte(uint8_t _data)
{
	TM7705_SetCS(0);
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = (_data);
	bsp_spiTransfer();
	TM7705_SetCS(1);
}

/*
*********************************************************************************************************
*	  : TM7705_Write3Byte
*	˵: д3ֽڡCS
*	    : _data Ҫд
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_Write3Byte(uint32_t _data)
{
	TM7705_SetCS(0);
	g_spiLen = 0;
	g_spiTxBuf[g_spiLen++] = ((_data >> 16) & 0xFF);
	g_spiTxBuf[g_spiLen++] = ((_data >> 8) & 0xFF);
	g_spiTxBuf[g_spiLen++] = (_data);
	bsp_spiTransfer();
	TM7705_SetCS(1);
}

/*
*********************************************************************************************************
*	  : TM7705_WaitDRDY
*	˵: ȴڲɡ У׼ʱϳҪȴ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void TM7705_WaitDRDY(void)
{
	uint32_t i;

	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return;
	}

	for (i = 0; i < 4000000; i++)
	{
		if (DRDY_IS_LOW())
		{
			break;
		}
	}
	if (i >= 4000000)
	{
		tm_printf("TM7705_WaitDRDY() Time Out ...\r\n");		/* . Ŵ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_WriteReg
*	˵: дָļĴ
*	    :  _RegID : ĴID
*			  _RegValue : Ĵֵ 8λļĴȡ32λβεĵ8bit
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_WriteReg(uint8_t _RegID, uint32_t _RegValue)
{
	uint8_t bits;

	switch (_RegID)
	{
		case REG_COMM:		/* ͨżĴ */
		case REG_SETUP:		/* üĴ 8bit */
		case REG_CLOCK:		/* ʱӼĴ 8bit */
			bits = 8;
			break;

		case REG_ZERO_CH1:	/* CH1 ƫƼĴ 24bit */
		case REG_FULL_CH1:	/* CH1 ̼Ĵ 24bit */
		case REG_ZERO_CH2:	/* CH2 ƫƼĴ 24bit */
		case REG_FULL_CH2:	/* CH2 ̼Ĵ 24bit*/
			bits = 24;
			break;

		case REG_DATA:		/* ݼĴ 16bit */
		default:
			return;
	}

	TM7705_WriteByte(_RegID | WRITE);	/* дͨżĴ, ָһдָдĸĴ */

	if (bits == 8)
	{
		TM7705_WriteByte((uint8_t)_RegValue);
	}
	else	/* 24bit */
	{
		TM7705_Write3Byte(_RegValue);
	}
}

/*
*********************************************************************************************************
*	  : TM7705_ReadReg
*	˵: дָļĴ
*	    :  _RegID : ĴID
*			  _RegValue : Ĵֵ 8λļĴȡ32λβεĵ8bit
*	  ֵ: ļĴֵ 8λļĴȡ32λβεĵ8bit
*********************************************************************************************************
*/
uint32_t TM7705_ReadReg(uint8_t _RegID)
{
	uint32_t read;

	switch (_RegID)
	{
		case REG_COMM:		/* ͨżĴ */
		case REG_SETUP:		/* üĴ 8bit */
		case REG_CLOCK:		/* ʱӼĴ 8bit */
			g_spiLen = 2;
			break;

		case REG_ZERO_CH1:	/* CH1 ƫƼĴ 24bit */
		case REG_FULL_CH1:	/* CH1 ̼Ĵ 24bit */
		case REG_ZERO_CH2:	/* CH2 ƫƼĴ 24bit */
		case REG_FULL_CH2:	/* CH2 ̼Ĵ 24bit*/
			g_spiLen = 4;
			break;

		case REG_DATA:		/* ݼĴ 16bit */
		default:
			return 0xFFFFFFFF;
	}

	g_spiTxBuf[0] = (_RegID | READ);	/* дͨżĴ, ָһдָдĸĴ */	
	bsp_spiTransfer();	
	if (g_spiLen == 2)			/* ؽ1ֽ */
	{
		read = g_spiRxBuf[1];
	}
	else if (g_spiLen == 4)		/* ؽ3ֽ */
	{
		read = (g_spiRxBuf[1] << 16) +  (g_spiRxBuf[2] << 8) + g_spiRxBuf[3];
	}
	return read;
}

/*
*********************************************************************************************************
*	  : TM7705_CalibSelf
*	˵: У׼. ڲԶ̽AIN+ AIN-У׼0λڲ̽ӵVref У׼λ˺ִй̽ϳ
*			  ʵԼ 180ms
*	    :  _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_CalibSelf(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_SELF | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ --- ʱϳԼ180ms */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ2 */
		TM7705_WriteByte(MD_CAL_SELF | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ  --- ʱϳԼ180ms */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_SytemCalibZero
*	˵: ϵͳУ׼λ. 뽫AIN+ AIN-̽ӺִиúУ׼ӦƲУ׼
*			 ִϺ󡣿ͨ TM7705_ReadReg(REG_ZERO_CH1)   TM7705_ReadReg(REG_ZERO_CH2) ȡУ׼
*	    : _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_SytemCalibZero(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_ZERO | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_ZERO | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_SytemCalibFull
*	˵: ϵͳУ׼λ. 뽫AIN+ AIN-ѹԴִиúУ׼ӦƲУ׼
*			 ִϺ󡣿ͨ TM7705_ReadReg(REG_FULL_CH1)   TM7705_ReadReg(REG_FULL_CH2) ȡУ׼
*	    :  _ch : ADCͨ12
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_SytemCalibFull(uint8_t _ch)
{
	if (_ch == 1)
	{
		/* У׼CH1 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_1);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_FULL | __CH1_GAIN_BIPOLAR_BUF | FSYNC_0);/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
	else if (_ch == 2)
	{
		/* У׼CH2 */
		TM7705_WriteByte(REG_SETUP | WRITE | CH_2);	/* дͨżĴһдüĴͨ1 */
		TM7705_WriteByte(MD_CAL_FULL | __CH2_GAIN_BIPOLAR_BUF | FSYNC_0);	/* У׼ */
		TM7705_WaitDRDY();	/* ȴڲ */
	}
}

/*
*********************************************************************************************************
*	  : TM7705_ReadAdcReg
*	˵: ͨ12ADCݡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static uint16_t TM7705_ReadAdcReg(uint8_t _cmd)
{
	uint16_t read;
	
	TM7705_SetCS(0);
	g_spiTxBuf[0] = _cmd;
	g_spiLen = 3;
	bsp_spiTransfer();
	read = (g_spiRxBuf[1] << 8) + g_spiRxBuf[2];
	TM7705_SetCS(1);
	
	return read;
}
	
/*
*********************************************************************************************************
*	  : TM7705_ReadAdc1
*	˵: ͨ12ADCݡ úִнǿԶȷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
uint16_t TM7705_ReadAdc(uint8_t _ch)
{
	uint8_t i;
	uint16_t read = 0;

	/* Ϊ˱ͨлɶʧЧ2 */
	for (i = 0; i < 2; i++)
	{
		TM7705_WaitDRDY();		/* ȴDRDYΪ0 */

		if (_ch == 1)
		{
			read = TM7705_ReadAdcReg(0x38);
		}
		else if (_ch == 2)
		{
			read = TM7705_ReadAdcReg(0x39);
		}	
	}
	return read;
}


/*
*********************************************************************************************************
*	  : TM7705_Scan2
*	˵: ɨ2ͨ뵽ѭʱɼADCֵŵȫֱȡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_Scan2(void)
{
	static uint8_t s_ch = 1;

	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return;
	}

	if (DRDY_IS_LOW())
	{
		/* ˫ͨ */
		if (s_ch == 1)
		{
			g_TM7705_Adc2 = TM7705_ReadAdcReg(0x38);

			s_ch = 2;
		}
		else
		{
			g_TM7705_Adc1 = TM7705_ReadAdcReg(0x39);

			s_ch = 1;
		}
	}
}

/*
*********************************************************************************************************
*	  : TM7705_Scan1
*	˵: ɨͨ1뵽ѭʱɼADCֵŵȫֱȡ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void TM7705_Scan1(void)
{
	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return;
	}

	if (DRDY_IS_LOW())
	{
		g_TM7705_Adc1 = TM7705_ReadAdcReg(0x38);
	}
}

/*
*********************************************************************************************************
*	  : TM7705_GetAdc1
*	˵: ȡɨĽҪ TM7705_Scan2()  TM7705_Scan1() ʹ
*	    : 
*	  ֵ: ͨ1ADCֵ
*********************************************************************************************************
*/
uint16_t TM7705_GetAdc1(void)
{
	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return 0;
	}

	return g_TM7705_Adc1;
}

/*
*********************************************************************************************************
*	  : TM7705_GetAdc2
*	˵: ȡɨĽ
*	    : 
*	  ֵ: ͨ2ADCֵ
*********************************************************************************************************
*/
uint16_t TM7705_GetAdc2(void)
{
	/* ʼʱδ⵽оƬٷأӰӦٶ */
	if (g_TM7705_OK == 0)
	{
		return 0;
	}

	return g_TM7705_Adc2;
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
