/*
*********************************************************************************************************
*
*	ģ : GPRSģSIM800
*	ļ : bsp_SIM800.c
*	     : V1.1
*	˵     : װSIMCOM˾SIM800ģصAT
*
*	޸ļ¼ :
*		汾               ˵
*		V1.0    2015-02-01  armfly  ʽ
*		V1.1    2015-06-21  armfly  
*							1.ƴ룬޸PowerOn()ֵ.
*							2.ʱжϳʱʹ bsp_GetRunTimer()ʵ
*
*	Copyright (C), 2015-2016,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

/*
	STM32-V6 ߷䣺
	SIM800_TERM_ON    PI0/GPRS_TERM_ON
	SIM800_RESET   	  PB7/GPRS_RESET
	SIM800_RX   	  PA2/USART2_TX
	SIM800_TX   	  PA3/USART2_RX
*/

/*
	AT+CREG?  ѯǰ״̬

	AT+CSQ ѯź

	AT+CIMI ѯSIM IMSI š

	AT+CIND? ȡǰָʾ״̬

	ATA 
	ATH Ҷ
	
	ATI ʾSIM800ģӲϢ
	
	ATD10086; 10086
*/

/* УʾʹչIO */
#define USE_HC574

#ifdef USE_HC574	/* ʹչIO */
	/* STM32SIM800PWRKEYż1NPNܣҪ */
	#define PWRKEY_1()		HC574_SetPin(GPRS_TERM_ON, 0)
	#define PWRKEY_0()		HC574_SetPin(GPRS_TERM_ON, 1)

	/* STM32MG323RESETż1NPNܣҪ. MG323RESETǵ帴λ */
	#define MG_RESET_1()	HC574_SetPin(GPRS_RESET, 0)
	#define MG_RESET_0()	HC574_SetPin(PORT_RESET, 1);
#else	/* ʹCPUIO */
	/* ڶӦRCCʱ */
	#define RCC_TERM_ON 	RCC_AHB1Periph_GPIOI
	#define PORT_TERM_ON	GPIOI
	#define PIN_TERM_ON		GPIO_PIN_0

	#define RCC_RESET 		RCC_AHB1Periph_GPIOB
	#define PORT_RESET		GPIOB
	#define PIN_RESET		GPIO_PIN_7

	/* STM32SIM800PWRKEYż1NPNܣҪ */
	#define PWRKEY_1()		GPIO_ResetBits(PORT_TERM_ON, PIN_TERM_ON);
	#define PWRKEY_0()		GPIO_SetBits(PORT_TERM_ON, PIN_TERM_ON);

	/* STM32MG323RESETż1NPNܣҪ. MG323RESETǵ帴λ */
	#define MG_RESET_1()	GPIO_ResetBits(PORT_RESET, PIN_RESET);
	#define MG_RESET_0()	GPIO_SetBits(PORT_RESET, PIN_RESET);
#endif

/*
*********************************************************************************************************
*	  : bsp_InitSIM800
*	˵: ģصGPIO,  ú bsp_Init() á
*	    :  
*	  ֵ: 
*********************************************************************************************************
*/
void bsp_InitSIM800(void)
{
#ifdef USE_HC574	/* ʹչIO */		
	PWRKEY_1();
#else
	GPIO_InitTypeDef GPIO_InitStructure;

	/* GPIOʱ */
	RCC_AHB1PeriphClockCmd(RCC_TERM_ON | RCC_RESET, ENABLE);

	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;		/* Ϊ */
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;		/* Ϊģʽ */
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	/* 費ʹ */
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;	/* IOٶ */

	PWRKEY_1();
	
	GPIO_InitStructure.GPIO_Pin = PIN_TERM_ON;
	GPIO_Init(PORT_TERM_ON, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = PIN_RESET;
	GPIO_Init(PORT_RESET, &GPIO_InitStructure);
#endif	

	/* CPUĴѾ bsp_uart_fifo.c е bsp_InitUart()  */
}

/*
*********************************************************************************************************
*	  : SIM800_PrintRxData
*	˵: ӡSTM32SIM800յݵCOM1ڣҪڸٵ
*	    : _ch : յ
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_PrintRxData(uint8_t _ch)
{
	#ifdef SIM800_TO_COM1_EN
		comSendChar(COM1, _ch);		/* յݴӡԴ1 */
	#endif
}

/*
*********************************************************************************************************
*	  : SIM800_PowerOn
*	˵: ģϵ. ڲжǷѾѿֱӷ1
*	    : 
*	  ֵ: 1 ʾϵɹ  0: ʾ쳣
*********************************************************************************************************
*/
uint8_t SIM800_PowerOn(void)
{
	uint8_t ret_value = 0;
	uint8_t i;
	
	/* жǷ񿪻 */
	for (i = 0; i < 5; i++)
	{
		SIM800_SendAT("AT");
		if (SIM800_WaitResponse("OK", 100))
		{
			return 1;
		}
	}
	
	comClearRxFifo(COM_SIM800);	/* 㴮ڽջ */

	/*  ͨ PWRKEY  1.2 Ȼͷţʹģ鿪*/
	PWRKEY_0();
	bsp_DelayMS(2000);
	PWRKEY_1();

	/* ȴģϵ磬ԶղRDT */
	//if (SIM800_WaitResponse("RDY", 5000) == 0)
	{	
		/* ʼͬ: ATֻյȷOK 
		  ģ鿪ӳ 2  3 ٷַͬûɷ͡ AT (дСд)ģ
		  ͬʣյģ鷵ء OK			
		*/
		for (i = 0; i < 50; i++)
		{
			SIM800_SendAT("OK");
			if (SIM800_WaitResponse("OK", 100))
			{
				ret_value = 1;
				break;			/* ģϵɹ */
			}
		}		
	}
	
	return ret_value;
}


/*
*********************************************************************************************************
*	  : SIM800_PowerOff
*	˵: SIM800ģػ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_PowerOff(void)
{
	/*
	ûͨPWRKEY ź1.5ػ,ʱ䳬33ģ¿
	
	ػУģȴעڲ밲ȫ״̬ұݣرڲ
	ԴϵǰģĴڽַ
	NORMAL POWER DOWN
	֮ģ齫ִATģػģʽRTCڼ״̬ػģʽͨ
	VDD_EXT⣬ڹػģʽ´Ϊ͵ƽ
	*/
	
	/* Ӳػ */
	PWRKEY_0();
	bsp_DelayMS(1500);
	PWRKEY_1();	
		
}

/*
*********************************************************************************************************
*	  : SIM800_WaitResponse
*	˵: ȴSIM800ָӦַ. ȴ OK
*	    : _pAckStr : Ӧַ Ȳó255
*			 _usTimeOut : ִгʱ0ʾһֱȴ. >ʾʱʱ䣬λ1ms
*	  ֵ: 1 ʾɹ  0 ʾʧ
*********************************************************************************************************
*/
uint8_t SIM800_WaitResponse(char *_pAckStr, uint16_t _usTimeOut)
{
	uint8_t ucData;
	uint8_t ucRxBuf[256];
	uint16_t pos = 0;
	uint32_t len;
	uint8_t ret;

	len = strlen(_pAckStr);
	if (len > 255)
	{
		return 0;
	}

	/* _usTimeOut == 0 ʾ޵ȴ */
	if (_usTimeOut > 0)
	{
		bsp_StartTimer(SIM800_TMR_ID, _usTimeOut);		/* ʹʱ3Ϊʱ */
	}
	while (1)
	{
		bsp_Idle();				/* CPUִеĲ  bsp.c  bsp.h ļ */

		if (_usTimeOut > 0)
		{
			if (bsp_CheckTimer(SIM800_TMR_ID))
			{
				ret = 0;	/* ʱ */
				break;
			}
		}

		if (comGetChar(COM_SIM800, &ucData))
		{
			SIM800_PrintRxData(ucData);		/* յݴӡԴ1 */

			if (ucData == '\n')
			{
				if (pos > 0)	/* 2յس */
				{
					if (memcmp(ucRxBuf, _pAckStr,  len) == 0)
					{
						ret = 1;	/* յָӦݣسɹ */
						break;
					}
					else
					{
						pos = 0;
					}
				}
				else
				{
					pos = 0;
				}
			}
			else
			{
				if (pos < sizeof(ucRxBuf))
				{
					/* ֻɼַ */
					if (ucData >= ' ')
					{
						ucRxBuf[pos++] = ucData;
					}
				}
			}
		}
	}
	return ret;
}

/*
*********************************************************************************************************
*	  : SIM800_ReadResponse
*	˵: ȡSIM800Ӧַúַ䳬ʱжϽ ҪATͺ
*	    : _pBuf : ģ鷵صַ
*			  _usBufSize : 󳤶
*			 _usTimeOut : ִгʱ0ʾһֱȴ. >0 ʾʱʱ䣬λ1ms
*	  ֵ: 0 ʾ󣨳ʱ  > 0 ʾӦݳ
*********************************************************************************************************
*/
uint16_t SIM800_ReadResponse(char *_pBuf, uint16_t _usBufSize, uint16_t _usTimeOut)
{
	uint8_t ucData;
	uint16_t pos = 0;
	uint8_t ret;
	uint8_t status = 0;		/* ״̬ */

	/* _usTimeOut == 0 ʾ޵ȴ */
	if (_usTimeOut > 0)
	{
		bsp_StartTimer(SIM800_TMR_ID, _usTimeOut);		/* ʹʱΪʱ */
	}
	while (1)
	{
		bsp_Idle();				/* CPUִеĲ  bsp.c  bsp.h ļ */

		if (status == 2)		/* ڽЧӦ׶Σַͨ䳬ʱжݽ */
		{
			if (bsp_CheckTimer(SIM800_TMR_ID))
			{
				_pBuf[pos]	 = 0;	/* β0 ںʶַ */
				ret = pos;		/* ɹ ݳ */
				break;
			}
		}
		else
		{
			if (_usTimeOut > 0)
			{
				if (bsp_CheckTimer(SIM800_TMR_ID))
				{
					ret = 0;	/* ʱ */
					break;
				}
			}
		}
		
		if (comGetChar(COM_SIM800, &ucData))
		{			
			SIM800_PrintRxData(ucData);		/* յݴӡԴ1 */

			switch (status)
			{
				case 0:			/* ַ */
					if (ucData == AT_CR)		/* ַǻسʾ AT */
					{
						_pBuf[pos++] = ucData;		/* յ */
						status = 2;	 /* ΪյģӦ */
					}
					else	/* ַ A ʾ AT */
					{
						status = 1;	 /* ͵ATַӦݣֱ CRַ */
					}
					break;
					
				case 1:			/* ATԽ׶, . ȴ */
					if (ucData == AT_CR)
					{
						status = 2;
					}
					break;
					
				case 2:			/* ʼģӦ */
					/* ֻҪյģӦַַ䳬ʱжϽʱܳʱ */
					bsp_StartTimer(SIM800_TMR_ID, 5);
					if (pos < _usBufSize - 1)
					{
						_pBuf[pos++] = ucData;		/* յ */
					}
					break;
			}
		}
	}
	return ret;
}

/*
*********************************************************************************************************
*	  : SIM800_SendAT
*	˵: GSMģ鷢AT ԶATַ<CR>ַ
*	    : _Str : ATַĩβĻس<CR>. ַ0
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_SendAT(char *_Cmd)
{
	comClearRxFifo(COM_SIM800);	/* 㴮ڽջ */	
	
	comSendBuf(COM_SIM800, (uint8_t *)_Cmd, strlen(_Cmd));
	comSendBuf(COM_SIM800, "\r", 1);
}

/*
*********************************************************************************************************
*	  : SIM800_SetEarVolume
*	˵: ö
*	    : _ucVolume :  0 - 100, 0ʾС
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_SetEarVolume(uint8_t _ucVolume)
{
	char CmdBuf[32];

	sprintf(CmdBuf, "AT+CLVL=%d", _ucVolume);
	SIM800_SendAT(CmdBuf);
}

/*
*********************************************************************************************************
*	  : SIM800_SetMicGain
*	˵: MIC  .    ú·ͨãֻм绰ǰʹá
*	    : _Channel : 0 Ƶͨ  1 Ƶͨ
*				_iGain : 档 0-15  ; 0ʾ0dB; 15ʾ+22.5dB
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_SetMicGain(uint16_t _Channel, uint16_t _iGain)
{
	char CmdBuf[32];
		
	sprintf(CmdBuf, "AT+CMIC=%d,%d", _Channel, _iGain);
	SIM800_SendAT(CmdBuf);
	
	
}


/*
*********************************************************************************************************
*	  : SIM800_DialTel
*	˵: 绰
*	    : _pTel 绰ַ
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_DialTel(char *_pTel)
{
	char CmdBuf[32];

	sprintf(CmdBuf, "ATD%s;", _pTel);
	SIM800_SendAT(CmdBuf);
}

/*
*********************************************************************************************************
*	  : SIM800_Hangup
*	˵: Ҷϵ绰
*	    : _pTel 绰ַ
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_Hangup(void)
{
	SIM800_SendAT("ATH");
}

/*
*********************************************************************************************************
*	  : SIM800_AnswerIncall
*	˵: 
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void SIM800_AnswerIncall(void)
{
	SIM800_SendAT("ATA");
}

/*
*********************************************************************************************************
*	  : SIM800_GetHardInfo
*	˵: ȡģӲϢ.  ATI Ӧ
*	    : ŽĽṹָ
*	  ֵ: 1 ʾɹ 0 ʾʧ
*********************************************************************************************************
*/
uint8_t SIM800_GetHardInfo(SIM800_INFO_T *_pInfo)
{
	/*
	ATI
	SIM800 R13.08

	OK
	
	AT+GSV
	SIMCOM_Ltd
	SIMCOM_SIM800
	Revision:1308B05SIM800M32
	*/	
	char buf[64];
	uint16_t len;
	char *p1, *p2;
	
	SIM800_SendAT("ATI");		/*  ATI  */	
	len = SIM800_ReadResponse(buf, sizeof(buf), 300);	/* ʱ 300ms */
	if (len == 0)
	{
		return 0;		
	}
	
	/* Ϣ涨д SIMCOM_Ltd */
	sprintf(_pInfo->Manfacture, "SIMCOM_Ltd");	
	_pInfo->Model[0] = 0;
	_pInfo->Revision[0] = 0;

	/* Ӧǰ2ַ \r\n */
	p1 = buf;
	p2 = strchr(p1, '\n');
	
	/* ͺ */
	p1 = p2 + 1;
	p2 = strchr(p1, ' ');
	len = p2 - p1;
	if (len >= sizeof(_pInfo->Model))
	{
		len = sizeof(_pInfo->Model) - 1;
	}		
	memcpy(_pInfo->Model, p1, len);
	_pInfo->Model[len] = 0;

	/* ͺ */
	p1 = p2 + 1;
	p2 = strchr(p1, '\r');
	len = p2 - p1;
	if (len >= sizeof(_pInfo->Revision))
	{
		len = sizeof(_pInfo->Revision) - 1;
	}				
	memcpy(_pInfo->Revision, p1, len);
	_pInfo->Revision[len] = 0;	
	
	return 1;
}

/*
*********************************************************************************************************
*	  : MG323_GetNetStatus
*	˵: ѯǰ״̬
*	    : 
*	  ֵ: ״̬, CREG_NO_REG, CREG_LOCAL_OK ȡ
*********************************************************************************************************
*/
uint8_t SIM800_GetNetStatus(void)
{
	/*
		AT+CREG?
		+CREG: 0,1
		
		OK				
	*/	
	char buf[128];
	uint16_t len, i;
	uint8_t status = 0;
	
	SIM800_SendAT("AT+CREG?");	/*  AT  */
	
	len = SIM800_ReadResponse(buf, sizeof(buf), 200);	/* ʱ 200ms */
	if (len == 0)
	{
		return 0;		
	}
	
	for (i = 2; i < len; i++)
	{
		if (buf[i] == ',')
		{
			i++;
			
			status = buf[i] - '0';
			break;
		}
	}
	return status;
}


/*****************************  www.armfly.com (END OF FILE) *********************************/
