/*
*********************************************************************************************************
*	                                  
*	ģ : STM32ڲŹ
*	ļ : bsp_watchdog.c
*	     : V1.0
*	˵     : STM32ڲŹIWDGʹڿŹWWDG
*	޸ļ¼ :
*		汾                ˵
*		V1.0    2015-10-06  armfly   ʽ
*
*	Copyright (C), 2015-2020,  www.armfly.com
*
*********************************************************************************************************
*/

#include "bsp.h"

static void bsp_InitIwdg(uint32_t _ulIWDGTime);

/*
*********************************************************************************************************
*	  : bsp_StartDog
*	˵: Ź ŹΪ 1000ms, ڿŹʹܡ
*	    : 
*	  ֵ: 		        
*********************************************************************************************************
*/
void bsp_StartDog(void)
{
	/* Ź, ʱ1000ms */
	bsp_InitIwdg(1000);
	
	
	/*
		ڿŹʼ
		ˢʱ: ~780 * (0x7f-0x50) = 36.6ms < refresh window < ~780 * 64 = 49.9ms
		
		üֵ 0x7fֵ 0x50ǲܹڼݼ 0x50 ֮ǰˢ		
	*/
	//bsp_InitWwdg(0x7f, 0x50, WWDG_Prescaler_8);
}

/*
*********************************************************************************************************
*	  : bsp_FeedDog
*	˵: ιԶŹ
*	    : 
*	  ֵ: 		        
*********************************************************************************************************
*/
void bsp_FeedDog(void)
{
	IWDG_ReloadCounter();
}

/*
*********************************************************************************************************
*	  : bsp_InitIwdg
*	˵: Źʱú
*	    : IWDGTime: 0 ---- 0x0FFF
*			  Źʱ,λΪms,IWDGTime = 1000 Լһʱ
*			  LSI = 34000
*	  ֵ: 		        
*********************************************************************************************************
*/
static void bsp_InitIwdg(uint32_t _ulIWDGTime)
{
		
	/* ϵͳǷӶŹλлָ */
	if (RCC_GetFlagStatus(RCC_FLAG_IWDGRST) != RESET)
	{		
		/* λ־ */
		RCC_ClearFlag();
	}
	else
	{
		/* ־û */
	}
	
	/* ʹLSI */
	RCC_LSICmd(ENABLE);
	
	/* ȴֱLSI */
	while (RCC_GetFlagStatus(RCC_FLAG_LSIRDY) == RESET)
	{}
	
	/* д0x5555ʾIWDG_PR IWDG_RLRĴ */
	IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
	
	/*  LSI/32 Ƶ ֮ڲ1ms */
	IWDG_SetPrescaler(IWDG_Prescaler_32);
	
	/*
		رע⣬_ulIWDGTimeСλms, װļʱ Ҫ1000
	 	Counter Reload Value = (_ulIWDGTime / 1000) /(1 / IWDG counter clock period)
	                      = (_ulIWDGTime / 1000) / (32/LSI)
	                      = (_ulIWDGTime / 1000) / (32/LsiFreq)
	                      = LsiFreq * _ulIWDGTime / 32000
	 	ʵʲLsiFreq = 34000ȡ1ʱ ž1ms 
	*/
	IWDG_SetReload(_ulIWDGTime);
	
	/* IWDG */
	IWDG_ReloadCounter();
	
	/* ʹ IWDG (LSI oscillator Ӳʹ) */
	IWDG_Enable();		
}

/*
*********************************************************************************************************
*	  : bsp_InitWwdg
*	˵: ڿŹ 
*	    Σ
*             _ucTreg       : T[6:0],ֵ 	Χ0x40  0x7F                                               
*             _ucWreg       : W[6:0],ֵ     С 0x80
*            WWDG_Prescaler : ڿŹƵ	PCLK1 = 42MHz
*                             WWDG_Prescaler_1: WWDG counter clock = (PCLK1/4096)/1
*							  WWDG_Prescaler_2: WWDG counter clock = (PCLK1/4096)/2
*							  WWDG_Prescaler_4: WWDG counter clock = (PCLK1/4096)/4
*							  WWDG_Prescaler_8: WWDG counter clock = (PCLK1/4096)/8 
*	  ֵ: 		        
*********************************************************************************************************
*/
void bsp_InitWwdg(uint8_t _ucTreg, uint8_t _ucWreg, uint32_t WWDG_Prescaler)
{
	NVIC_InitTypeDef NVIC_InitStructure;
	
	/* ϵͳǷӴڿŹλлָ */
	if (RCC_GetFlagStatus(RCC_FLAG_WWDGRST) != RESET)
	{ 	
		/* λ־ */
		RCC_ClearFlag();
	}
	else
	{
		/* WWDGRST ־û */
	}
	
	/* ʹWWDGʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);
	
	/* 
	   ڿŹƵã
	   ѡWWDG_Prescaler_8
	   (PCLK1 (42MHz)/4096)/8 = 1281 Hz (~780 us)  
	*/
	WWDG_SetPrescaler(WWDG_Prescaler);
	
	/* 
	 ôֵ_ucWregûС_ucWregҴ0x40ʱˢ¼
	 Ҫϵͳλ
    */
	WWDG_SetWindowValue(_ucWreg);
	
	/* 
	 ʹWWDGü
	 _ucTreg=127 8Ƶʱôʱ= ~780 us * 64 = 49.92 ms 
	 ڿŹˢʱ: ~780 * (127-80) = 36.6ms < ˢ´ڿŹ < ~780 * 64 = 49.9ms
	*/
	WWDG_Enable(_ucTreg);
	
	/* EWIжϱ־ */
	WWDG_ClearFlag();	

	/* ʹEWж */
	WWDG_EnableIT();

    /*  WWDG NVIC */
	NVIC_InitStructure.NVIC_IRQChannel = WWDG_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);	
}


/*
*********************************************************************************************************
*	  : WWDG_IRQHandler
*	˵: ڿŹжϷ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
void WWDG_IRQHandler(void)
{
	/*رע⣬ִ˳ܷˣ˾ͳ*/
	/* EWI־ */
	if (WWDG_GetFlagStatus != RESET)
	{
		/* λ־ */
		WWDG_ClearFlag();
		
		/* ´ڿŹ */
		WWDG_SetCounter(127);
	}	
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
