/*
*********************************************************************************************************
*
*	ģ : SDRAMܲļ
*	ļ : demo_fmc_sdram.c
*	     : V1.0
*	˵     : ⲿ32λSDRAMܲԡ
*              1SDRAMͺIS42S32800G-6BLI, 32λ, 32MB, 6nsٶ(166MHz)
*              2. K1£32MBдٶ;
*              3. K2£32MBٶ;
*              4. K3£ȡ1024ֽڲӡ;
*              5. ҡOK£SDRAMеԪǷ쳣;
*              6. Cache
*                1ʹMDKIARĸŻȼԣŻӰС
*                2дٶ376MB/Sٶ182MB/S
*              7. رCache
*                1ʹMDKIARĸŻȼԣŻӰС
*                2дٶ307MB/Sٶ116MB/S
*              8. IARߵȼŻٶ189MB/SMDK182MB/Sߵ㡣
*              9. MDKʵ鿪ߵȼŻʱŻ
*              10. IARʵ鿪ߵȼٶŻ
*	޸ļ¼ :
*		汾                    ˵
*		V1.0    2018-12-12   Eric2013     1. CMSIS汾 V5.4.0
*                                         2. HAL汾 V1.3.0
*
*	Copyright (C), 2018-2030,  www.armfly.com
*
*********************************************************************************************************
*/	
#include "bsp.h"			/* ײӲ */



/* ļڲú */
static void PrintfHelp(void);
static void WriteSpeedTest(void);
static void ReadSpeedTest(void);
static void ReadWriteTest(void);

#define TEST_ADDRESS	0    /* ӵַ0ʼ */
#define TEST_BUF_SIZE	256  /* ԻС */

/*
*********************************************************************************************************
*	  : DemoFmcSRAM
*	˵: SDRAMдܲ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void DemoFmcSRAM(void)
{
	uint8_t ucKeyCode;	/*  */
	uint32_t err;
	
	PrintfHelp();	/* ӡʾ */

	bsp_StartAutoTimer(0, 100);	/* 1100msԶװĶʱ */
	
	/* ѭ */
	while (1)
	{
		bsp_Idle();		/* bsp.cļû޸ʵCPUߺι */

		/* ж϶ʱʱʱ */
		if (bsp_CheckTimer(0))	
		{
			/* ÿ100ms һ */  
			bsp_LedToggle(2);
		}

		/* ˲ͼɺ̨systickжϷʵֻ֣Ҫbsp_GetKeyȡֵɡ */
		ucKeyCode = bsp_GetKey();	/* ȡֵ, ޼ʱ KEY_NONE = 0 */
		if (ucKeyCode != KEY_NONE)
		{
			switch (ucKeyCode)
			{
				case KEY_DOWN_K1:			/* K1£32MBдٶ */
					WriteSpeedTest();
					break;

				case KEY_DOWN_K2:			/* K2£32MBٶ*/
					ReadSpeedTest();
					break;
				
				case KEY_DOWN_K3:			/* K3£ȡ1024ֽڲӡ */
					ReadWriteTest();
					break;
				
				case JOY_DOWN_OK:			/* ҡOK£SDRAMеԪǷ쳣*/
					err = bsp_TestExtSDRAM1();
					if (err == 0)
					{
						printf("ⲿSDRAMͨ\r\n");
					}
					else
					{
						printf("ⲿSDRAMԪ%d\r\n", err);
					}
					break;

				default:
					/* ļֵ */
					break;
			}
		}
	}
}

/*
*********************************************************************************************************
*	  : WriteSpeedTest
*	˵: дSDRAMٶȲ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void WriteSpeedTest(void)
{
	uint32_t start, end, cnt;
	uint32_t i, j;
	int32_t iTime1, iTime2;
	uint32_t *pBuf;


	/* óʼֵ¿ʼʱ */
	j = 0;
	pBuf = (uint32_t *)EXT_SDRAM_ADDR;
	iTime1 = bsp_GetRunTime();	  
	start = DWT_CYCCNT;
	
	/* ԵķʽдݵSDRAMпռ */
	for (i = 1024*1024/4; i >0 ; i--)
	{
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;	

		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;	

		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;	

		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;
		*pBuf++ = j++;	
	}
	end = DWT_CYCCNT;
	cnt = end - start;
	iTime2 = bsp_GetRunTime();	/* ½ʱ */
	
    /* ȡдǷ */
	j = 0;
	pBuf = (uint32_t *)EXT_SDRAM_ADDR;
	for (i = 0; i < 1024*1024*8; i++)
	{
		if(*pBuf++ != j++)
		{
			printf("д j=%d\r\n", j);
			break;
		}
	}
		
	/* ӡٶ */
	printf("32MBдʱ: ʽһ:%dms  ʽ:%dms, дٶ: %dMB/s\r\n", 
	                  iTime2 - iTime1,  cnt/400000, (EXT_SDRAM_SIZE / 1024 /1024 * 1000) / (iTime2 - iTime1));
}

/*
*********************************************************************************************************
*	  : ReadSpeedTest
*	˵: SDRAMٶȲ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void ReadSpeedTest(void)
{	
	uint32_t start, end, cnt;
	uint32_t i;
	int32_t iTime1, iTime2;
	uint32_t *pBuf;
	__IO  uint32_t ulTemp; /* Ϊ__IOֹͣMDKŻ */

	/* óʼֵ¿ʼʱ */
	pBuf = (uint32_t *)EXT_SDRAM_ADDR;
	iTime1 = bsp_GetRunTime();	
	start = DWT_CYCCNT;
	
	/* ȡSDRAMпռ */	
	for (i = 1024*1024/4; i >0 ; i--)
	{
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;

		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
		ulTemp = *pBuf++;
	}
	end = DWT_CYCCNT;
	cnt = end - start;
	iTime2 = bsp_GetRunTime();	/* ½ʱ */

	/* ӡٶ */
	printf("32MBݶʱ: ʽһ:%dms  ʽ:%dms, ٶ: %dMB/s\r\n", 
	        iTime2 - iTime1,  cnt/400000, (EXT_SDRAM_SIZE / 1024 /1024 * 1000) / (iTime2 - iTime1));
}

/*
*********************************************************************************************************
*	  : ReadWriteTest
*	˵: ݣӡ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void ReadWriteTest(void)
{
	uint32_t i;
	uint32_t *pBuf;
	

	/* д0xAAAA5555 */
	pBuf = (uint32_t *)(EXT_SDRAM_ADDR + TEST_ADDRESS);
	for (i = 0; i < TEST_BUF_SIZE; i++)		
	{
		pBuf[i] = 0xAAAA5555;
	}
	
	printf("ַ0x%08X  С: %dֽ  ʾ: %dֽ  : \r\n", EXT_SDRAM_ADDR + TEST_ADDRESS, EXT_SDRAM_SIZE, TEST_BUF_SIZE*4);
	
	/* ӡ */
	pBuf = (uint32_t *)(EXT_SDRAM_ADDR + TEST_ADDRESS);
	for (i = 0; i < TEST_BUF_SIZE; i++)
	{
		printf(" %04X", pBuf[i]);

		if ((i & 7) == 7)
		{
			printf("\r\n");		/* ÿʾ32ֽ */
		}
		else if ((i & 7) == 3)
		{
			printf(" - ");
		}
	}
}

/*
*********************************************************************************************************
*	  : PrintfHelp
*	˵: ӡʾ
*	    : 
*	  ֵ: 
*********************************************************************************************************
*/
static void PrintfHelp(void)
{
	printf("ʾ:\r\n");	
	printf("SDRAMͺIS42S32800G-6BLI, 32λ, 32MB, 6nsٶ(166MHz)\r\n");
	printf("1. K1£32MBдٶ\r\n");
	printf("2. K2£32MBٶ\r\n");
	printf("3. K3£ȡ1024ֽڲӡ\r\n");
	printf("4. ҡOK£SDRAMеԪǷ쳣\r\n");
}

/*****************************  www.armfly.com (END OF FILE) *********************************/
